date
LITMUSOPTS="${@:-$LITMUSOPTS}"
TDIR=$(dirname $0)
ARM_RUN="${ARM_RUN:-./arm-run}"
dorun () {
  EXE=$1
  shift
  OPTS="$@"
  ${ARM_RUN} ${TDIR}/${EXE} -smp 24 -append "${OPTS}"
}
SLEEP=1
if [ ! -f R+tlbi.ishspteafpteoa+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+tlbi.ishspteafpte
"TLBI.ISHsWWPteAFPteOA CoePteOAPteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | LDR X2,[X0]     ;
 LDR X5,[X0]     | LDR X5,[X0]     ;

locations [0:X5; 1:X5; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+tlbi.ishspteafpte.t
dorun ./R+tlbi.ishspteafpteoa+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafpteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+tlbi.ishsppte
"TLBI.ISHsWWPteAFPteOA CoePteOAP TLBI.ISHsWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | MOV W0,#1       ;
 LSR X4,X3,#12   | STR W0,[X1]     ;
 DSB ISH         | LSR X4,X1,#12   ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 STR X2,[X0]     | DSB ISH         ;
 LDR X5,[X0]     | LDR X3,[X2]     ;
                 | LDR X5,[X2]     ;

locations [x; 0:X5; 1:X5; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+tlbi.ishsppte.t
dorun ./R+tlbi.ishspteafpteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+tlbi.ishsptepte
"TLBI.ISHsWWPteAFPteOA RfePteOAPte TLBI.ISHsRRPtePte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | LDR X2,[X0]     ;
 LDR X5,[X0]     | LDR X5,[X0]     ;

locations [0:X5; 1:X5; 1:X1; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+tlbi.ishsptepte.t
dorun ./MP+tlbi.ishspteafpteoa+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+tlbi.ishsppte
"TLBI.ISHsWWPteAFPteOA RfePteOAP TLBI.ISHsRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | LDR X3,[X2]     ;
 LDR X5,[X0]     | LDR X5,[X2]     ;

locations [0:X5; 1:X5; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+tlbi.ishsppte.t
dorun ./MP+tlbi.ishspteafpteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafpteoa+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+dsb.syspteafpte
"TLBI.ISHsWWPteAFPteOA CoePteOAPteAF DSB.SYsWRPteAFPte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | STR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR X2,[X0] ;
 TLBI VAAE1IS,X4 | LDR X3,[X0] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X3; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+dsb.syspteafpte.t
dorun ./R+tlbi.ishspteafpteoa+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafpteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+dsb.sysppte
"TLBI.ISHsWWPteAFPteOA CoePteOAP DSB.SYsWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | MOV W0,#1   ;
 LSR X4,X3,#12   | STR W0,[X1] ;
 DSB ISH         | DSB SY      ;
 TLBI VAAE1IS,X4 | LDR X3,[X2] ;
 DSB ISH         | LDR X4,[X2] ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [x; 0:X5; 1:X4; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+dsb.sysppte.t
dorun ./R+tlbi.ishspteafpteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+dsb.sysptepte
"TLBI.ISHsWWPteAFPteOA RfePteOAPte DSB.SYsRRPtePte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR X2,[X0] ;
 TLBI VAAE1IS,X4 | LDR X3,[X0] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X3; 1:X1; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+dsb.sysptepte.t
dorun ./MP+tlbi.ishspteafpteoa+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+dsb.sysppte
"TLBI.ISHsWWPteAFPteOA RfePteOAP DSB.SYsRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X4 | LDR X4,[X2] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X4; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+dsb.sysppte.t
dorun ./MP+tlbi.ishspteafpteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafpteoa+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+tlbi.ishspteafp
"TLBI.ISHsWWPteAFPteOA CoePteOAPteAF TLBI.ISHsWRPteAFP FrePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X2,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | LDR W3,[X2]     ;
 LDR X5,[X0]     |                 ;

locations [0:X5; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+tlbi.ishspteafp.t
dorun ./R+tlbi.ishspteafpteoa+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafpteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+tlbi.ishs
"TLBI.ISHsWWPteAFPteOA CoePteOAP TLBI.ISHsWR FrePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x;}

 P0              | P1              ;
 STR X1,[X0]     | MOV W0,#1       ;
 LSR X4,X3,#12   | STR W0,[X1]     ;
 DSB ISH         | LSR X3,X1,#12   ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X3 ;
 STR X2,[X0]     | DSB ISH         ;
 LDR X5,[X0]     | LDR W2,[X1]     ;

locations [x; 0:X5; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+tlbi.ishs.t
dorun ./R+tlbi.ishspteafpteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+tlbi.ishsptep
"TLBI.ISHsWWPteAFPteOA RfePteOAPte TLBI.ISHsRRPteP FrePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; 1:X2=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X2,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | LDR W3,[X2]     ;
 LDR X5,[X0]     |                 ;

locations [0:X5; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+tlbi.ishsptep.t
dorun ./MP+tlbi.ishspteafpteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+tlbi.ishs
"TLBI.ISHsWWPteAFPteOA RfePteOAP TLBI.ISHsRR FrePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X3,#12   | LSR X3,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X3 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | LDR W2,[X0]     ;
 LDR X5,[X0]     |                 ;

locations [0:X5; 1:X1; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+tlbi.ishs.t
dorun ./MP+tlbi.ishspteafpteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafpteoa+dsb.syspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+dsb.syspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+dsb.syspteafp
"TLBI.ISHsWWPteAFPteOA CoePteOAPteAF DSB.SYsWRPteAFP FrePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1          ;
 STR X1,[X0]     | STR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR W3,[X2] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+dsb.syspteafp.t
dorun ./R+tlbi.ishspteafpteoa+dsb.syspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafpteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafpteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafpteoa+dsb.sys
"TLBI.ISHsWWPteAFPteOA CoePteOAP DSB.SYsWR FrePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x;}

 P0              | P1          ;
 STR X1,[X0]     | MOV W0,#1   ;
 LSR X4,X3,#12   | STR W0,[X1] ;
 DSB ISH         | DSB SY      ;
 TLBI VAAE1IS,X4 | LDR W2,[X1] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [x; 0:X5; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafpteoa+dsb.sys.t
dorun ./R+tlbi.ishspteafpteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+dsb.sysptep
"TLBI.ISHsWWPteAFPteOA RfePteOAPte DSB.SYsRRPteP FrePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; 1:X2=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR W3,[X2] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+dsb.sysptep.t
dorun ./MP+tlbi.ishspteafpteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafpteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafpteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafpteoa+dsb.sys
"TLBI.ISHsWWPteAFPteOA RfePteOAP DSB.SYsRR FrePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR W2,[X0] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X1; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafpteoa+dsb.sys.t
dorun ./MP+tlbi.ishspteafpteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishspteafpteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+tlbi.ishspteafpteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishspteafpteoas
"TLBI.ISHsWWPteAFPteOA CoePteOAPteAF TLBI.ISHsWWPteAFPteOA CoePteOAPteAF"

{pteval_t 1:X4=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X3,X2,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X3 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | STR X1,[X0]     ;
 LDR X5,[X0]     | LDR X4,[X0]     ;

locations [0:X5; 1:X4;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishspteafpteoas.t
dorun ./2+2W+tlbi.ishspteafpteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishsppteoa+tlbi.ishspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+tlbi.ishsppteoa+tlbi.ishspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishsppteoa+tlbi.ishspteafpteoa
"TLBI.ISHsWWPPteOA CoePteOAPteAF TLBI.ISHsWWPteAFPteOA CoePteOAP"

{pteval_t 1:X4=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X3,X2,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X3 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X1,[X0]     ;
 STR X3,[X2]     | LDR X4,[X0]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X4; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishsppteoa+tlbi.ishspteafpteoa.t
dorun ./2+2W+tlbi.ishsppteoa+tlbi.ishspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+tlbi.ishsptepteoa
"TLBI.ISHsWWPteAFPteOA RfePteOAPte TLBI.ISHsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | STR X2,[X0]     ;
 LDR X5,[X0]     | LDR X5,[X0]     ;

locations [0:X5; 1:X5; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+tlbi.ishsptepteoa.t
dorun ./S+tlbi.ishspteafpteoa+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+tlbi.ishsppteoa
"TLBI.ISHsWWPteAFPteOA RfePteOAP TLBI.ISHsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | STR X3,[X2]     ;
 LDR X5,[X0]     | LDR X5,[X2]     ;

locations [0:X5; 1:X5; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+tlbi.ishsppteoa.t
dorun ./S+tlbi.ishspteafpteoa+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafpteoa+tlbi.ishspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafpteoa+tlbi.ishspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafpteoa+tlbi.ishspteafpteoa
"DSB.SYsWWPteAFPteOA CoePteOAPteAF TLBI.ISHsWWPteAFPteOA CoePteOAPteAF"

{pteval_t 1:X4=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X3,X2,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | STR X1,[X0]     ;
             | LDR X4,[X0]     ;

locations [0:X3; 1:X4;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafpteoa+tlbi.ishspteafpteoa.t
dorun ./2+2W+dsb.syspteafpteoa+tlbi.ishspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sysppteoa+tlbi.ishspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sysppteoa+tlbi.ishspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sysppteoa+tlbi.ishspteafpteoa
"DSB.SYsWWPPteOA CoePteOAPteAF TLBI.ISHsWWPteAFPteOA CoePteOAP"

{pteval_t 1:X4=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X3,X2,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X3 ;
 LDR X4,[X2] | DSB ISH         ;
             | STR X1,[X0]     ;
             | LDR X4,[X0]     ;

locations [x; 0:X4; 1:X4; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sysppteoa+tlbi.ishspteafpteoa.t
dorun ./2+2W+dsb.sysppteoa+tlbi.ishspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+dsb.sysptepteoa
"TLBI.ISHsWWPteAFPteOA RfePteOAPte DSB.SYsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X3=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | STR X2,[X0] ;
 TLBI VAAE1IS,X4 | LDR X3,[X0] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X3; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+dsb.sysptepteoa.t
dorun ./S+tlbi.ishspteafpteoa+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+dsb.sysppteoa
"TLBI.ISHsWWPteAFPteOA RfePteOAP DSB.SYsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X4=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | STR X3,[X2] ;
 TLBI VAAE1IS,X4 | LDR X4,[X2] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [0:X5; 1:X4; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+dsb.sysppteoa.t
dorun ./S+tlbi.ishspteafpteoa+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishspteafp+tlbi.ishspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+tlbi.ishspteafp+tlbi.ishspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishspteafp+tlbi.ishspteafpteoa
"TLBI.ISHsWWPteAFP CoePPteAF TLBI.ISHsWWPteAFPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X2,[X0]     ;
 STR W2,[X3]     | LDR X5,[X0]     ;

locations [x; 1:X5; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishspteafp+tlbi.ishspteafpteoa.t
dorun ./2+2W+tlbi.ishspteafp+tlbi.ishspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishs+tlbi.ishspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+tlbi.ishs+tlbi.ishspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishs+tlbi.ishspteafpteoa
"TLBI.ISHsWW CoePPteAF TLBI.ISHsWWPteAFPteOA CoePteOAP"

{pteval_t 1:X5=0; y=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X3,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X3 | DSB ISH         ;
 DSB ISH         | STR X2,[X0]     ;
 MOV W2,#2       | LDR X5,[X0]     ;
 STR W2,[X1]     |                 ;

locations [x; 1:X5; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishs+tlbi.ishspteafpteoa.t
dorun ./2+2W+tlbi.ishs+tlbi.ishspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+tlbi.ishsptep
"TLBI.ISHsWWPteAFPteOA RfePteOAPte TLBI.ISHsRWPteP CoePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | MOV W2,#1       ;
 LDR X5,[X0]     | STR W2,[X3]     ;

locations [x; 0:X5; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+tlbi.ishsptep.t
dorun ./S+tlbi.ishspteafpteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+tlbi.ishs
"TLBI.ISHsWWPteAFPteOA RfePteOAP TLBI.ISHsRW CoePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X3,#12   | LSR X3,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X3 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | MOV W2,#1       ;
 LDR X5,[X0]     | STR W2,[X0]     ;

locations [x; 0:X5; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+tlbi.ishs.t
dorun ./S+tlbi.ishspteafpteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafp+tlbi.ishspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafp+tlbi.ishspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafp+tlbi.ishspteafpteoa
"DSB.SYsWWPteAFP CoePPteAF TLBI.ISHsWWPteAFPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 1:X5; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafp+tlbi.ishspteafpteoa.t
dorun ./2+2W+dsb.syspteafp+tlbi.ishspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sys+tlbi.ishspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sys+tlbi.ishspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sys+tlbi.ishspteafpteoa
"DSB.SYsWW CoePPteAF TLBI.ISHsWWPteAFPteOA CoePteOAP"

{pteval_t 1:X5=0; y=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#2   | TLBI VAAE1IS,X4 ;
 STR W2,[X1] | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 1:X5; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sys+tlbi.ishspteafpteoa.t
dorun ./2+2W+dsb.sys+tlbi.ishspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+dsb.sysptep
"TLBI.ISHsWWPteAFPteOA RfePteOAPte DSB.SYsRWPteP CoePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; 1:X3=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | MOV W2,#1   ;
 TLBI VAAE1IS,X4 | STR W2,[X3] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [x; 0:X5; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+dsb.sysptep.t
dorun ./S+tlbi.ishspteafpteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafpteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafpteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafpteoa+dsb.sys
"TLBI.ISHsWWPteAFPteOA RfePteOAP DSB.SYsRW CoePPteAF"

{pteval_t 0:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | MOV W2,#1   ;
 TLBI VAAE1IS,X4 | STR W2,[X0] ;
 DSB ISH         |             ;
 STR X2,[X0]     |             ;
 LDR X5,[X0]     |             ;

locations [x; 0:X5; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafpteoa+dsb.sys.t
dorun ./S+tlbi.ishspteafpteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+tlbi.ishspteafpte
"TLBI.ISHsWWPPteOA CoePteOAPteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X2,[X0]     ;
 STR X3,[X2]     | LDR X5,[X0]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+tlbi.ishspteafpte.t
dorun ./R+tlbi.ishsppteoa+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+tlbi.ishsppte
"TLBI.ISHsWWPPteOA CoePteOAP TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#2       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR X3,[X2]     ;
 LDR X5,[X2]     | LDR X5,[X2]     ;

locations [x; 0:X5; 1:X5; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+tlbi.ishsppte.t
dorun ./R+tlbi.ishsppteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+tlbi.ishsptepte
"TLBI.ISHsWWPPteOA RfePteOAPte TLBI.ISHsRRPtePte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X2,[X0]     ;
 STR X3,[X2]     | LDR X5,[X0]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X5; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+tlbi.ishsptepte.t
dorun ./MP+tlbi.ishsppteoa+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+tlbi.ishsppte
"TLBI.ISHsWWPPteOA RfePteOAP TLBI.ISHsRRPPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 STR X3,[X2]     | LDR X5,[X2]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X5; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+tlbi.ishsppte.t
dorun ./MP+tlbi.ishsppteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+dsb.syspteafpte
"TLBI.ISHsWWPPteOA CoePteOAPteAF DSB.SYsWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | STR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X2,[X0] ;
 DSB ISH         | LDR X3,[X0] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+dsb.syspteafpte.t
dorun ./R+tlbi.ishsppteoa+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+dsb.sysppte
"TLBI.ISHsWWPPteOA CoePteOAP DSB.SYsWRPPte FrePteP"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | MOV W0,#2   ;
 STR W0,[X1]     | STR W0,[X1] ;
 LSR X4,X1,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X4 | LDR X4,[X2] ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X4; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+dsb.sysppte.t
dorun ./R+tlbi.ishsppteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+dsb.sysptepte
"TLBI.ISHsWWPPteOA RfePteOAPte DSB.SYsRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X2,[X0] ;
 DSB ISH         | LDR X3,[X0] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X3; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+dsb.sysptepte.t
dorun ./MP+tlbi.ishsppteoa+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+dsb.sysppte
"TLBI.ISHsWWPPteOA RfePteOAP DSB.SYsRRPPte FrePteP"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X3,[X2] ;
 DSB ISH         | LDR X4,[X2] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X4; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+dsb.sysppte.t
dorun ./MP+tlbi.ishsppteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+tlbi.ishspteafp
"TLBI.ISHsWWPPteOA CoePteOAPteAF TLBI.ISHsWRPteAFP Fre"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X2,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W3,[X2]     ;
 STR X3,[X2]     |                 ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+tlbi.ishspteafp.t
dorun ./R+tlbi.ishsppteoa+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+tlbi.ishs
"TLBI.ISHsWWPPteOA CoePteOAP TLBI.ISHsWR Fre"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#2       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X3,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X3 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR W2,[X1]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+tlbi.ishs.t
dorun ./R+tlbi.ishsppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+tlbi.ishsptep
"TLBI.ISHsWWPPteOA RfePteOAPte TLBI.ISHsRRPteP Fre"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X2=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X2,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W3,[X2]     ;
 STR X3,[X2]     |                 ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+tlbi.ishsptep.t
dorun ./MP+tlbi.ishsppteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+tlbi.ishs
"TLBI.ISHsWWPPteOA RfePteOAP TLBI.ISHsRR Fre"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X3,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X3 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W2,[X0]     ;
 STR X3,[X2]     |                 ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X1; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+tlbi.ishs.t
dorun ./MP+tlbi.ishsppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+dsb.syspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+dsb.syspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+dsb.syspteafp
"TLBI.ISHsWWPPteOA CoePteOAPteAF DSB.SYsWRPteAFP Fre"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1          ;
 MOV W0,#1       | STR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR W3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+dsb.syspteafp.t
dorun ./R+tlbi.ishsppteoa+dsb.syspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishsppteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishsppteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishsppteoa+dsb.sys
"TLBI.ISHsWWPPteOA CoePteOAP DSB.SYsWR Fre"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x;}

 P0              | P1          ;
 MOV W0,#1       | MOV W0,#2   ;
 STR W0,[X1]     | STR W0,[X1] ;
 LSR X4,X1,#12   | DSB SY      ;
 DSB ISH         | LDR W2,[X1] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishsppteoa+dsb.sys.t
dorun ./R+tlbi.ishsppteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+dsb.sysptep
"TLBI.ISHsWWPPteOA RfePteOAPte DSB.SYsRRPteP Fre"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X2=x;}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR W3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+dsb.sysptep.t
dorun ./MP+tlbi.ishsppteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishsppteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishsppteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishsppteoa+dsb.sys
"TLBI.ISHsWWPPteOA RfePteOAP DSB.SYsRR Fre"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR W2,[X0] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X1; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishsppteoa+dsb.sys.t
dorun ./MP+tlbi.ishsppteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishsppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+tlbi.ishsppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishsppteoas
"TLBI.ISHsWWPPteOA CoePteOAP TLBI.ISHsWWPPteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#2       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;
 LDR X5,[X2]     | LDR X5,[X2]     ;

locations [x; 0:X5; 1:X5; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishsppteoas.t
dorun ./2+2W+tlbi.ishsppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoa+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoa+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoa+tlbi.ishsptepteoa
"TLBI.ISHsWWPPteOA RfePteOAPte TLBI.ISHsRWPtePteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X2,[X0]     ;
 STR X3,[X2]     | LDR X5,[X0]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoa+tlbi.ishsptepteoa.t
dorun ./S+tlbi.ishsppteoa+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoas
"TLBI.ISHsWWPPteOA RfePteOAP TLBI.ISHsRWPPteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 STR X3,[X2]     | LDR X5,[X2]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoas.t
dorun ./S+tlbi.ishsppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafpteoa+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafpteoa+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafpteoa+tlbi.ishsppteoa
"DSB.SYsWWPteAFPteOA CoePteOAP TLBI.ISHsWWPPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X2,[X0] | LSR X4,X1,#12   ;
 LDR X3,[X0] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X3; 1:X5; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafpteoa+tlbi.ishsppteoa.t
dorun ./2+2W+dsb.syspteafpteoa+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sysppteoa+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sysppteoa+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sysppteoa+tlbi.ishsppteoa
"DSB.SYsWWPPteOA CoePteOAP TLBI.ISHsWWPPteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X4; 1:X5; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sysppteoa+tlbi.ishsppteoa.t
dorun ./2+2W+dsb.sysppteoa+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoa+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoa+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoa+dsb.sysptepteoa
"TLBI.ISHsWWPPteOA RfePteOAPte DSB.SYsRWPtePteOA CoePteOAP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | STR X2,[X0] ;
 DSB ISH         | LDR X3,[X0] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoa+dsb.sysptepteoa.t
dorun ./S+tlbi.ishsppteoa+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoa+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoa+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoa+dsb.sysppteoa
"TLBI.ISHsWWPPteOA RfePteOAP DSB.SYsRWPPteOA CoePteOAP"

{pteval_t 1:X4=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | STR X3,[X2] ;
 DSB ISH         | LDR X4,[X2] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoa+dsb.sysppteoa.t
dorun ./S+tlbi.ishsppteoa+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishsppteoa+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+tlbi.ishsppteoa+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishsppteoa+tlbi.ishspteafp
"TLBI.ISHsWWPPteOA CoePteOAPteAF TLBI.ISHsWWPteAFP Coe"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | MOV W2,#2       ;
 STR X3,[X2]     | STR W2,[X3]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishsppteoa+tlbi.ishspteafp.t
dorun ./2+2W+tlbi.ishsppteoa+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishs+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+tlbi.ishs+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishs+tlbi.ishsppteoa
"TLBI.ISHsWW Coe TLBI.ISHsWWPPteOA CoePteOAP"

{pteval_t 1:X5=0; y=0; 0:X1=x; 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#3       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X3,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X3 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#2       | STR X3,[X2]     ;
 STR W2,[X1]     | LDR X5,[X2]     ;

locations [x; 1:X5; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishs+tlbi.ishsppteoa.t
dorun ./2+2W+tlbi.ishs+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoa+tlbi.ishsptep
"TLBI.ISHsWWPPteOA RfePteOAPte TLBI.ISHsRWPteP Coe"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | MOV W2,#2       ;
 STR X3,[X2]     | STR W2,[X3]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoa+tlbi.ishsptep.t
dorun ./S+tlbi.ishsppteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoa+tlbi.ishs
"TLBI.ISHsWWPPteOA RfePteOAP TLBI.ISHsRW Coe"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X3,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X3 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | MOV W2,#2       ;
 STR X3,[X2]     | STR W2,[X0]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoa+tlbi.ishs.t
dorun ./S+tlbi.ishsppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafp+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafp+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafp+tlbi.ishsppteoa
"DSB.SYsWWPteAFP Coe TLBI.ISHsWWPPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#2       ;
 DSB SY      | STR W0,[X1]     ;
 MOV W2,#1   | LSR X4,X1,#12   ;
 STR W2,[X3] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 1:X5; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafp+tlbi.ishsppteoa.t
dorun ./2+2W+dsb.syspteafp+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sys+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sys+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sys+tlbi.ishsppteoa
"DSB.SYsWW Coe TLBI.ISHsWWPPteOA CoePteOAP"

{pteval_t 1:X5=0; y=0; 0:X1=x; 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#3       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 MOV W2,#2   | DSB ISH         ;
 STR W2,[X1] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 1:X5; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sys+tlbi.ishsppteoa.t
dorun ./2+2W+dsb.sys+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoa+dsb.sysptep
"TLBI.ISHsWWPPteOA RfePteOAPte DSB.SYsRWPteP Coe"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | MOV W2,#2   ;
 DSB ISH         | STR W2,[X3] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoa+dsb.sysptep.t
dorun ./S+tlbi.ishsppteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishsppteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishsppteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishsppteoa+dsb.sys
"TLBI.ISHsWWPPteOA RfePteOAP DSB.SYsRW Coe"

{pteval_t 0:X5=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | MOV W2,#2   ;
 DSB ISH         | STR W2,[X0] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;
 LDR X5,[X2]     |             ;

locations [x; 0:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishsppteoa+dsb.sys.t
dorun ./S+tlbi.ishsppteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishspteafptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+tlbi.ishspteafptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishspteafptes
"TLBI.ISHsWRPteAFPte FrePtePteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X5=0; pteval_t 0:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 LDR X2,[X0]     | LDR X2,[X0]     ;
 LDR X5,[X0]     | LDR X5,[X0]     ;

locations [0:X5; 0:X2; 1:X5; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishspteafptes.t
dorun ./SB+tlbi.ishspteafptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishsppte+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+tlbi.ishsppte+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishsppte+tlbi.ishspteafpte
"TLBI.ISHsWRPPte FrePtePteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X5=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X2,[X0]     ;
 LDR X3,[X2]     | LDR X5,[X0]     ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 0:X3; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishsppte+tlbi.ishspteafpte.t
dorun ./SB+tlbi.ishsppte+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafpte+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafpte+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafpte+tlbi.ishspteafpte
"DSB.SYsWRPteAFPte FrePtePteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X3=0; pteval_t 0:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 LDR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [0:X3; 0:X2; 1:X5; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafpte+tlbi.ishspteafpte.t
dorun ./SB+dsb.syspteafpte+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sysppte+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sysppte+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sysppte+tlbi.ishspteafpte
"DSB.SYsWRPPte FrePtePteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X4=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 LDR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 0:X4; 0:X3; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sysppte+tlbi.ishspteafpte.t
dorun ./SB+dsb.sysppte+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishspteafp+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+tlbi.ishspteafp+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishspteafp+tlbi.ishspteafpte
"TLBI.ISHsWRPteAFP FrePPteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X4,X2,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 LDR W3,[X2]     | LDR X2,[X0]     ;
                 | LDR X5,[X0]     ;

locations [0:X3; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishspteafp+tlbi.ishspteafpte.t
dorun ./SB+tlbi.ishspteafp+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishs+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+tlbi.ishs+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishs+tlbi.ishspteafpte
"TLBI.ISHsWR FrePPteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X3,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X3 | DSB ISH         ;
 DSB ISH         | LDR X2,[X0]     ;
 LDR W2,[X1]     | LDR X5,[X0]     ;

locations [x; 0:X2; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishs+tlbi.ishspteafpte.t
dorun ./SB+tlbi.ishs+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafp+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafp+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafp+tlbi.ishspteafpte
"DSB.SYsWRPteAFP FrePPteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 LDR W3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [0:X3; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafp+tlbi.ishspteafpte.t
dorun ./SB+dsb.syspteafp+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sys+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sys+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sys+tlbi.ishspteafpte
"DSB.SYsWR FrePPteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 LDR W2,[X1] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 0:X2; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sys+tlbi.ishspteafpte.t
dorun ./SB+dsb.sys+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+tlbi.ishspteafpte
"DSB.SYsWWPteAFPteOA CoePteOAPteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [0:X3; 1:X5; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+tlbi.ishspteafpte.t
dorun ./R+dsb.syspteafpteoa+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+tlbi.ishspteafpte
"DSB.SYsWWPPteOA CoePteOAPteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 0:X4; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+tlbi.ishspteafpte.t
dorun ./R+dsb.sysppteoa+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafp+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafp+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafp+tlbi.ishspteafpte
"TLBI.ISHsWWPteAFP CoePPteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | LDR X2,[X0]     ;
 STR W2,[X3]     | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafp+tlbi.ishspteafpte.t
dorun ./R+tlbi.ishspteafp+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishs+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishs+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishs+tlbi.ishspteafpte
"TLBI.ISHsWW CoePPteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X3,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X3 | DSB ISH         ;
 DSB ISH         | LDR X2,[X0]     ;
 MOV W2,#2       | LDR X5,[X0]     ;
 STR W2,[X1]     |                 ;

locations [x; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishs+tlbi.ishspteafpte.t
dorun ./R+tlbi.ishs+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafp+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafp+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafp+tlbi.ishspteafpte
"DSB.SYsWWPteAFP CoePPteAF TLBI.ISHsWRPteAFPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafp+tlbi.ishspteafpte.t
dorun ./R+dsb.syspteafp+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sys+tlbi.ishspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sys+tlbi.ishspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sys+tlbi.ishspteafpte
"DSB.SYsWW CoePPteAF TLBI.ISHsWRPteAFPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#2   | TLBI VAAE1IS,X4 ;
 STR W2,[X1] | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sys+tlbi.ishspteafpte.t
dorun ./R+dsb.sys+tlbi.ishspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishspptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+tlbi.ishspptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishspptes
"TLBI.ISHsWRPPte FrePteP TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#2       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 LDR X3,[X2]     | LDR X3,[X2]     ;

locations [x; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishspptes.t
dorun ./SB+tlbi.ishspptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafpte+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafpte+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafpte+tlbi.ishsppte
"DSB.SYsWRPteAFPte FrePteP TLBI.ISHsWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X3=0; pteval_t 0:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 LDR X2,[X0] | LSR X4,X1,#12   ;
 LDR X3,[X0] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X3; 0:X2; 1:X5; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafpte+tlbi.ishsppte.t
dorun ./SB+dsb.syspteafpte+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sysppte+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sysppte+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sysppte+tlbi.ishsppte
"DSB.SYsWRPPte FrePteP TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 LDR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sysppte+tlbi.ishsppte.t
dorun ./SB+dsb.sysppte+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishsppte+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+tlbi.ishsppte+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishsppte+tlbi.ishspteafp
"TLBI.ISHsWRPPte FrePtePteAF TLBI.ISHsWRPteAFP Fre"

{pteval_t 0:X5=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X2,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W3,[X2]     ;
 LDR X3,[X2]     |                 ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishsppte+tlbi.ishspteafp.t
dorun ./SB+tlbi.ishsppte+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishs+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+tlbi.ishs+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishs+tlbi.ishsppte
"TLBI.ISHsWR Fre TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#2       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X3,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X3 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 LDR W2,[X1]     | LDR X3,[X2]     ;

locations [x; 0:X2; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishs+tlbi.ishsppte.t
dorun ./SB+tlbi.ishs+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafp+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafp+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafp+tlbi.ishsppte
"DSB.SYsWRPteAFP Fre TLBI.ISHsWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 LDR W3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X3; 1:X5; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafp+tlbi.ishsppte.t
dorun ./SB+dsb.syspteafp+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sys+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sys+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sys+tlbi.ishsppte
"DSB.SYsWR Fre TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 LDR W2,[X1] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 0:X2; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sys+tlbi.ishsppte.t
dorun ./SB+dsb.sys+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+tlbi.ishsppte
"DSB.SYsWWPteAFPteOA CoePteOAP TLBI.ISHsWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X2,[X0] | LSR X4,X1,#12   ;
 LDR X3,[X0] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X3; 1:X5; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+tlbi.ishsppte.t
dorun ./R+dsb.syspteafpteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+tlbi.ishsppte
"DSB.SYsWWPPteOA CoePteOAP TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X4; 1:X5; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+tlbi.ishsppte.t
dorun ./R+dsb.sysppteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafp+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafp+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafp+tlbi.ishsppte
"TLBI.ISHsWWPteAFP Coe TLBI.ISHsWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | MOV W0,#2       ;
 LSR X4,X3,#12   | STR W0,[X1]     ;
 DSB ISH         | LSR X4,X1,#12   ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 MOV W2,#1       | DSB ISH         ;
 STR W2,[X3]     | LDR X3,[X2]     ;
                 | LDR X5,[X2]     ;

locations [x; 1:X5; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafp+tlbi.ishsppte.t
dorun ./R+tlbi.ishspteafp+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishs+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishs+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishs+tlbi.ishsppte
"TLBI.ISHsWW Coe TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#3       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X3,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X3 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#2       | LDR X3,[X2]     ;
 STR W2,[X1]     |                 ;

locations [x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishs+tlbi.ishsppte.t
dorun ./R+tlbi.ishs+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafp+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafp+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafp+tlbi.ishsppte
"DSB.SYsWWPteAFP Coe TLBI.ISHsWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#2       ;
 DSB SY      | STR W0,[X1]     ;
 MOV W2,#1   | LSR X4,X1,#12   ;
 STR W2,[X3] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 1:X5; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafp+tlbi.ishsppte.t
dorun ./R+dsb.syspteafp+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sys+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sys+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sys+tlbi.ishsppte
"DSB.SYsWW Coe TLBI.ISHsWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#3       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 MOV W2,#2   | DSB ISH         ;
 STR W2,[X1] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sys+tlbi.ishsppte.t
dorun ./R+dsb.sys+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishsptepteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+tlbi.ishsptepteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishsptepteoas
"TLBI.ISHsRWPtePteOA RfePteOAPte TLBI.ISHsRWPtePteOA RfePteOAPte"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X5=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 LDR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X2,[X0]     | STR X2,[X0]     ;
 LDR X5,[X0]     | LDR X5,[X0]     ;

locations [0:X5; 0:X1; 1:X5; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishsptepteoas.t
dorun ./LB+tlbi.ishsptepteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishsppteoa+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+tlbi.ishsppteoa+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishsppteoa+tlbi.ishsptepteoa
"TLBI.ISHsRWPPteOA RfePteOAPte TLBI.ISHsRWPtePteOA RfePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 LDR W1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X0,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X2,[X0]     ;
 LDR X5,[X2]     | LDR X5,[X0]     ;

locations [0:X5; 0:X1; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishsppteoa+tlbi.ishsptepteoa.t
dorun ./LB+tlbi.ishsppteoa+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+tlbi.ishsptepteoa
"DSB.SYsWWPteAFPteOA RfePteOAPte TLBI.ISHsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [0:X3; 1:X5; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+tlbi.ishsptepteoa.t
dorun ./S+dsb.syspteafpteoa+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoa+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoa+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoa+tlbi.ishsptepteoa
"DSB.SYsWWPPteOA RfePteOAPte TLBI.ISHsRWPtePteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 0:X4; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoa+tlbi.ishsptepteoa.t
dorun ./S+dsb.sysppteoa+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptepteoa+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptepteoa+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptepteoa+tlbi.ishsptepteoa
"DSB.SYsRWPtePteOA RfePteOAPte TLBI.ISHsRWPtePteOA RfePteOAPte"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X3=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 LDR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [0:X3; 0:X1; 1:X5; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptepteoa+tlbi.ishsptepteoa.t
dorun ./LB+dsb.sysptepteoa+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysppteoa+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysppteoa+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysppteoa+tlbi.ishsptepteoa
"DSB.SYsRWPPteOA RfePteOAPte TLBI.ISHsRWPtePteOA RfePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 LDR W1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [0:X4; 0:X1; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysppteoa+tlbi.ishsptepteoa.t
dorun ./LB+dsb.sysppteoa+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafp+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafp+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafp+tlbi.ishsptepteoa
"TLBI.ISHsWWPteAFP RfePPte TLBI.ISHsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X5=0; pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X2,[X0]     ;
 STR W2,[X3]     | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafp+tlbi.ishsptepteoa.t
dorun ./S+tlbi.ishspteafp+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishs+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishs+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishs+tlbi.ishsptepteoa
"TLBI.ISHsWW RfePPte TLBI.ISHsRWPtePteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; y=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X3,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X3 | DSB ISH         ;
 DSB ISH         | STR X2,[X0]     ;
 MOV W2,#2       | LDR X5,[X0]     ;
 STR W2,[X1]     |                 ;

locations [x; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishs+tlbi.ishsptepteoa.t
dorun ./S+tlbi.ishs+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishsptep+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+tlbi.ishsptep+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishsptep+tlbi.ishsptepteoa
"TLBI.ISHsRWPteP RfePPte TLBI.ISHsRWPtePteOA RfePteOAPte"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 LDR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X2,[X0]     ;
 STR W2,[X3]     | LDR X5,[X0]     ;

locations [x; 0:X1; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishsptep+tlbi.ishsptepteoa.t
dorun ./LB+tlbi.ishsptep+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishs+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+tlbi.ishs+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishs+tlbi.ishsptepteoa
"TLBI.ISHsRW RfePPte TLBI.ISHsRWPtePteOA RfePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; y=0; 0:X0=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0              | P1              ;
 LDR W1,[X0]     | LDR X1,[X0]     ;
 LSR X3,X0,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X3 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X2,[X0]     ;
 STR W2,[X0]     | LDR X5,[X0]     ;

locations [x; 0:X1; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishs+tlbi.ishsptepteoa.t
dorun ./LB+tlbi.ishs+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafp+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafp+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafp+tlbi.ishsptepteoa
"DSB.SYsWWPteAFP RfePPte TLBI.ISHsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X5=0; pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafp+tlbi.ishsptepteoa.t
dorun ./S+dsb.syspteafp+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sys+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sys+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sys+tlbi.ishsptepteoa
"DSB.SYsWW RfePPte TLBI.ISHsRWPtePteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; y=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#2   | TLBI VAAE1IS,X4 ;
 STR W2,[X1] | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sys+tlbi.ishsptepteoa.t
dorun ./S+dsb.sys+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptep+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptep+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptep+tlbi.ishsptepteoa
"DSB.SYsRWPteP RfePPte TLBI.ISHsRWPtePteOA RfePteOAPte"

{pteval_t 1:X5=0; pteval_t 1:X1=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 LDR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 0:X1; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptep+tlbi.ishsptepteoa.t
dorun ./LB+dsb.sysptep+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sys+tlbi.ishsptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sys+tlbi.ishsptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sys+tlbi.ishsptepteoa
"DSB.SYsRW RfePPte TLBI.ISHsRWPtePteOA RfePteOAP"

{pteval_t 1:X5=0; pteval_t 1:X1=0; y=0; 0:X0=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 LDR W1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 0:X1; 1:X5; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sys+tlbi.ishsptepteoa.t
dorun ./LB+dsb.sys+tlbi.ishsptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishsppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+tlbi.ishsppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishsppteoas
"TLBI.ISHsRWPPteOA RfePteOAP TLBI.ISHsRWPPteOA RfePteOAP"

{pteval_t 1:X5=0; pteval_t 0:X5=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 LDR W1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X0,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;
 LDR X5,[X2]     | LDR X5,[X2]     ;

locations [0:X5; 0:X1; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishsppteoas.t
dorun ./LB+tlbi.ishsppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+tlbi.ishsppteoa
"DSB.SYsWWPteAFPteOA RfePteOAP TLBI.ISHsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [0:X3; 1:X5; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+tlbi.ishsppteoa.t
dorun ./S+dsb.syspteafpteoa+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoa+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoa+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoa+tlbi.ishsppteoa
"DSB.SYsWWPPteOA RfePteOAP TLBI.ISHsRWPPteOA CoePteOAP"

{pteval_t 1:X5=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X4; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoa+tlbi.ishsppteoa.t
dorun ./S+dsb.sysppteoa+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptepteoa+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptepteoa+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptepteoa+tlbi.ishsppteoa
"DSB.SYsRWPtePteOA RfePteOAP TLBI.ISHsRWPPteOA RfePteOAPte"

{pteval_t 1:X5=0; pteval_t 0:X3=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [0:X3; 0:X1; 1:X5; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptepteoa+tlbi.ishsppteoa.t
dorun ./LB+dsb.sysptepteoa+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysppteoa+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysppteoa+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysppteoa+tlbi.ishsppteoa
"DSB.SYsRWPPteOA RfePteOAP TLBI.ISHsRWPPteOA RfePteOAP"

{pteval_t 1:X5=0; pteval_t 0:X4=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR W1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [0:X4; 0:X1; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysppteoa+tlbi.ishsppteoa.t
dorun ./LB+dsb.sysppteoa+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafp+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafp+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafp+tlbi.ishsppteoa
"TLBI.ISHsWWPteAFP Rfe TLBI.ISHsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     | LDR X5,[X2]     ;

locations [x; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafp+tlbi.ishsppteoa.t
dorun ./S+tlbi.ishspteafp+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishs+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishs+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishs+tlbi.ishsppteoa
"TLBI.ISHsWW Rfe TLBI.ISHsRWPPteOA CoePteOAP"

{pteval_t 1:X5=0; y=0; 0:X1=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X3,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X3 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 MOV W2,#2       | LDR X5,[X2]     ;
 STR W2,[X1]     |                 ;

locations [x; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishs+tlbi.ishsppteoa.t
dorun ./S+tlbi.ishs+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishsppteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+tlbi.ishsppteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishsppteoa+tlbi.ishsptep
"TLBI.ISHsRWPPteOA RfePteOAPte TLBI.ISHsRWPteP Rfe"

{pteval_t 1:X1=0; pteval_t 0:X5=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0              | P1              ;
 LDR W1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X0,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | MOV W2,#1       ;
 LDR X5,[X2]     | STR W2,[X3]     ;

locations [x; 0:X5; 0:X1; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishsppteoa+tlbi.ishsptep.t
dorun ./LB+tlbi.ishsppteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishs+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+tlbi.ishs+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishs+tlbi.ishsppteoa
"TLBI.ISHsRW Rfe TLBI.ISHsRWPPteOA RfePteOAP"

{pteval_t 1:X5=0; y=0; 0:X0=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 LDR W1,[X0]     | LDR W1,[X0]     ;
 LSR X3,X0,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X3 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X0]     | LDR X5,[X2]     ;

locations [x; 0:X1; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishs+tlbi.ishsppteoa.t
dorun ./LB+tlbi.ishs+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafp+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafp+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafp+tlbi.ishsppteoa
"DSB.SYsWWPteAFP Rfe TLBI.ISHsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X5=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafp+tlbi.ishsppteoa.t
dorun ./S+dsb.syspteafp+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sys+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sys+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sys+tlbi.ishsppteoa
"DSB.SYsWW Rfe TLBI.ISHsRWPPteOA CoePteOAP"

{pteval_t 1:X5=0; y=0; 0:X1=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#2   | TLBI VAAE1IS,X4 ;
 STR W2,[X1] | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sys+tlbi.ishsppteoa.t
dorun ./S+dsb.sys+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptep+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptep+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptep+tlbi.ishsppteoa
"DSB.SYsRWPteP Rfe TLBI.ISHsRWPPteOA RfePteOAPte"

{pteval_t 1:X5=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; 0:X3=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X1; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptep+tlbi.ishsppteoa.t
dorun ./LB+dsb.sysptep+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sys+tlbi.ishsppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sys+tlbi.ishsppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sys+tlbi.ishsppteoa
"DSB.SYsRW Rfe TLBI.ISHsRWPPteOA RfePteOAP"

{pteval_t 1:X5=0; y=0; 0:X0=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR W1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X1; 1:X5; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sys+tlbi.ishsppteoa.t
dorun ./LB+dsb.sys+tlbi.ishsppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+tlbi.ishsptepte
"DSB.SYsWWPteAFPteOA RfePteOAPte TLBI.ISHsRRPtePte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [0:X3; 1:X5; 1:X1; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+tlbi.ishsptepte.t
dorun ./MP+dsb.syspteafpteoa+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+tlbi.ishsptepte
"DSB.SYsWWPPteOA RfePteOAPte TLBI.ISHsRRPtePte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 0:X4; 1:X5; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+tlbi.ishsptepte.t
dorun ./MP+dsb.sysppteoa+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafp+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafp+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafp+tlbi.ishsptepte
"TLBI.ISHsWWPteAFP RfePPte TLBI.ISHsRRPtePte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X3,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | LDR X2,[X0]     ;
 STR W2,[X3]     | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafp+tlbi.ishsptepte.t
dorun ./MP+tlbi.ishspteafp+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishs+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishs+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishs+tlbi.ishsptepte
"TLBI.ISHsWW RfePPte TLBI.ISHsRRPtePte FrePteP"

{pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X1=x; 1:X0=pte_x; 1:X3=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X4,X3,#12   ;
 LSR X3,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X3 | DSB ISH         ;
 DSB ISH         | LDR X2,[X0]     ;
 MOV W2,#2       |                 ;
 STR W2,[X1]     |                 ;

locations [x; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishs+tlbi.ishsptepte.t
dorun ./MP+tlbi.ishs+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafp+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafp+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafp+tlbi.ishsptepte
"DSB.SYsWWPteAFP RfePPte TLBI.ISHsRRPtePte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X2,[X0]     ;
             | LDR X5,[X0]     ;

locations [x; 1:X5; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafp+tlbi.ishsptepte.t
dorun ./MP+dsb.syspteafp+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sys+tlbi.ishsptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sys+tlbi.ishsptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sys+tlbi.ishsptepte
"DSB.SYsWW RfePPte TLBI.ISHsRRPtePte FrePteP"

{pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X1=x; 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#2   | TLBI VAAE1IS,X4 ;
 STR W2,[X1] | DSB ISH         ;
             | LDR X2,[X0]     ;

locations [x; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sys+tlbi.ishsptepte.t
dorun ./MP+dsb.sys+tlbi.ishsptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+tlbi.ishsppte
"DSB.SYsWWPteAFPteOA RfePteOAP TLBI.ISHsRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [0:X3; 1:X5; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+tlbi.ishsppte.t
dorun ./MP+dsb.syspteafpteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+tlbi.ishsppte
"DSB.SYsWWPPteOA RfePteOAP TLBI.ISHsRRPPte FrePteP"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 0:X4; 1:X5; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+tlbi.ishsppte.t
dorun ./MP+dsb.sysppteoa+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafp+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafp+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafp+tlbi.ishsppte
"TLBI.ISHsWWPteAFP Rfe TLBI.ISHsRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X3,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | LDR X3,[X2]     ;
 STR W2,[X3]     | LDR X5,[X2]     ;

locations [x; 1:X5; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafp+tlbi.ishsppte.t
dorun ./MP+tlbi.ishspteafp+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishs+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishs+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishs+tlbi.ishsppte
"TLBI.ISHsWW Rfe TLBI.ISHsRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X0=x; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X3,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X3 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 MOV W2,#2       |                 ;
 STR W2,[X1]     |                 ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishs+tlbi.ishsppte.t
dorun ./MP+tlbi.ishs+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafp+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafp+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafp+tlbi.ishsppte
"DSB.SYsWWPteAFP Rfe TLBI.ISHsRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [x; 1:X5; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafp+tlbi.ishsppte.t
dorun ./MP+dsb.syspteafp+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sys+tlbi.ishsppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sys+tlbi.ishsppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sys+tlbi.ishsppte
"DSB.SYsWW Rfe TLBI.ISHsRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X0=x; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#2   | TLBI VAAE1IS,X4 ;
 STR W2,[X1] | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sys+tlbi.ishsppte.t
dorun ./MP+dsb.sys+tlbi.ishsppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+dsb.syspteafpte
"DSB.SYsWWPteAFPteOA CoePteOAPteAF DSB.SYsWRPteAFPte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 0:X3=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | LDR X2,[X0] ;
 LDR X3,[X0] | LDR X3,[X0] ;

locations [0:X3; 1:X3; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+dsb.syspteafpte.t
dorun ./R+dsb.syspteafpteoa+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+dsb.sysppte
"DSB.SYsWWPteAFPteOA CoePteOAP DSB.SYsWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | MOV W0,#1   ;
 DSB SY      | STR W0,[X1] ;
 STR X2,[X0] | DSB SY      ;
 LDR X3,[X0] | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [x; 0:X3; 1:X4; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+dsb.sysppte.t
dorun ./R+dsb.syspteafpteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+dsb.sysptepte
"DSB.SYsWWPteAFPteOA RfePteOAPte DSB.SYsRRPtePte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | LDR X2,[X0] ;
 LDR X3,[X0] | LDR X3,[X0] ;

locations [0:X3; 1:X3; 1:X1; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+dsb.sysptepte.t
dorun ./MP+dsb.syspteafpteoa+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+dsb.sysppte
"DSB.SYsWWPteAFPteOA RfePteOAP DSB.SYsRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | LDR X3,[X2] ;
 LDR X3,[X0] | LDR X4,[X2] ;

locations [0:X3; 1:X4; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+dsb.sysppte.t
dorun ./MP+dsb.syspteafpteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+tlbi.ishspteafp
"DSB.SYsWWPteAFPteOA CoePteOAPteAF TLBI.ISHsWRPteAFP FrePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X2,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [0:X3; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+tlbi.ishspteafp.t
dorun ./R+dsb.syspteafpteoa+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+tlbi.ishs
"DSB.SYsWWPteAFPteOA CoePteOAP TLBI.ISHsWR FrePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X1=x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X2,[X0] | LSR X3,X1,#12   ;
 LDR X3,[X0] | DSB ISH         ;
             | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | LDR W2,[X1]     ;

locations [x; 0:X3; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+tlbi.ishs.t
dorun ./R+dsb.syspteafpteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+tlbi.ishsptep
"DSB.SYsWWPteAFPteOA RfePteOAPte TLBI.ISHsRRPteP FrePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X2=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X2,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [0:X3; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+tlbi.ishsptep.t
dorun ./MP+dsb.syspteafpteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+tlbi.ishs
"DSB.SYsWWPteAFPteOA RfePteOAP TLBI.ISHsRR FrePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X3,X0,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | LDR W2,[X0]     ;

locations [0:X3; 1:X1; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+tlbi.ishs.t
dorun ./MP+dsb.syspteafpteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+dsb.syspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+dsb.syspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+dsb.syspteafp
"DSB.SYsWWPteAFPteOA CoePteOAPteAF DSB.SYsWRPteAFP FrePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | LDR W3,[X2] ;
 LDR X3,[X0] |             ;

locations [0:X3; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+dsb.syspteafp.t
dorun ./R+dsb.syspteafpteoa+dsb.syspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafpteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafpteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafpteoa+dsb.sys
"DSB.SYsWWPteAFPteOA CoePteOAP DSB.SYsWR FrePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X1=x;}

 P0          | P1          ;
 STR X1,[X0] | MOV W0,#1   ;
 DSB SY      | STR W0,[X1] ;
 STR X2,[X0] | DSB SY      ;
 LDR X3,[X0] | LDR W2,[X1] ;

locations [x; 0:X3; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafpteoa+dsb.sys.t
dorun ./R+dsb.syspteafpteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+dsb.sysptep
"DSB.SYsWWPteAFPteOA RfePteOAPte DSB.SYsRRPteP FrePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X2=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | LDR W3,[X2] ;
 LDR X3,[X0] |             ;

locations [0:X3; 1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+dsb.sysptep.t
dorun ./MP+dsb.syspteafpteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafpteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafpteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafpteoa+dsb.sys
"DSB.SYsWWPteAFPteOA RfePteOAP DSB.SYsRR FrePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | LDR W2,[X0] ;
 LDR X3,[X0] |             ;

locations [0:X3; 1:X1; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafpteoa+dsb.sys.t
dorun ./MP+dsb.syspteafpteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafpteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafpteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafpteoas
"DSB.SYsWWPteAFPteOA CoePteOAPteAF DSB.SYsWWPteAFPteOA CoePteOAPteAF"

{pteval_t 1:X2=0; pteval_t 0:X3=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | STR X1,[X0] ;
 LDR X3,[X0] | LDR X2,[X0] ;

locations [0:X3; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafpteoas.t
dorun ./2+2W+dsb.syspteafpteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sysppteoa+dsb.syspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sysppteoa+dsb.syspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sysppteoa+dsb.syspteafpteoa
"DSB.SYsWWPPteOA CoePteOAPteAF DSB.SYsWWPteAFPteOA CoePteOAP"

{pteval_t 1:X2=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X1,[X0] ;
 STR X3,[X2] | LDR X2,[X0] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sysppteoa+dsb.syspteafpteoa.t
dorun ./2+2W+dsb.sysppteoa+dsb.syspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+dsb.sysptepteoa
"DSB.SYsWWPteAFPteOA RfePteOAPte DSB.SYsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X3=0; pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | STR X2,[X0] ;
 LDR X3,[X0] | LDR X3,[X0] ;

locations [0:X3; 1:X3; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+dsb.sysptepteoa.t
dorun ./S+dsb.syspteafpteoa+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+dsb.sysppteoa
"DSB.SYsWWPteAFPteOA RfePteOAP DSB.SYsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X4=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | STR X3,[X2] ;
 LDR X3,[X0] | LDR X4,[X2] ;

locations [0:X3; 1:X4; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+dsb.sysppteoa.t
dorun ./S+dsb.syspteafpteoa+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafpteoa+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafpteoa+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafpteoa+tlbi.ishspteafp
"DSB.SYsWWPteAFPteOA CoePteOAPteAF TLBI.ISHsWWPteAFP CoePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafpteoa+tlbi.ishspteafp.t
dorun ./2+2W+dsb.syspteafpteoa+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafpteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafpteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafpteoa+tlbi.ishs
"DSB.SYsWWPteAFPteOA CoePteOAP TLBI.ISHsWW CoePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X1=x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X2,[X0] | LSR X3,X1,#12   ;
 LDR X3,[X0] | DSB ISH         ;
             | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | MOV W2,#2       ;
             | STR W2,[X1]     ;

locations [x; 0:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafpteoa+tlbi.ishs.t
dorun ./2+2W+dsb.syspteafpteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+tlbi.ishsptep
"DSB.SYsWWPteAFPteOA RfePteOAPte TLBI.ISHsRWPteP CoePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X3; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+tlbi.ishsptep.t
dorun ./S+dsb.syspteafpteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+tlbi.ishs
"DSB.SYsWWPteAFPteOA RfePteOAP TLBI.ISHsRW CoePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X3,X0,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X0]     ;

locations [x; 0:X3; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+tlbi.ishs.t
dorun ./S+dsb.syspteafpteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syspteafp+dsb.syspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.syspteafp+dsb.syspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syspteafp+dsb.syspteafpteoa
"DSB.SYsWWPteAFP CoePPteAF DSB.SYsWWPteAFPteOA CoePteOAPteAF"

{pteval_t 1:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X2,[X0] ;
 STR W2,[X3] | LDR X3,[X0] ;

locations [x; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syspteafp+dsb.syspteafpteoa.t
dorun ./2+2W+dsb.syspteafp+dsb.syspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sys+dsb.syspteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sys+dsb.syspteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sys+dsb.syspteafpteoa
"DSB.SYsWW CoePPteAF DSB.SYsWWPteAFPteOA CoePteOAP"

{pteval_t 1:X3=0; y=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X2,[X0] ;
 MOV W2,#2   | LDR X3,[X0] ;
 STR W2,[X1] |             ;

locations [x; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sys+dsb.syspteafpteoa.t
dorun ./2+2W+dsb.sys+dsb.syspteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+dsb.sysptep
"DSB.SYsWWPteAFPteOA RfePteOAPte DSB.SYsRWPteP CoePPteAF"

{pteval_t 1:X1=0; pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | MOV W2,#1   ;
 LDR X3,[X0] | STR W2,[X3] ;

locations [x; 0:X3; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+dsb.sysptep.t
dorun ./S+dsb.syspteafpteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafpteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafpteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafpteoa+dsb.sys
"DSB.SYsWWPteAFPteOA RfePteOAP DSB.SYsRW CoePPteAF"

{pteval_t 0:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); pteval_t 0:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | MOV W2,#1   ;
 LDR X3,[X0] | STR W2,[X0] ;

locations [x; 0:X3; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafpteoa+dsb.sys.t
dorun ./S+dsb.syspteafpteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+dsb.syspteafpte
"DSB.SYsWWPPteOA CoePteOAPteAF DSB.SYsWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X2,[X0] ;
 STR X3,[X2] | LDR X3,[X0] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+dsb.syspteafpte.t
dorun ./R+dsb.sysppteoa+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+dsb.sysppte
"DSB.SYsWWPPteOA CoePteOAP DSB.SYsWRPPte FrePteP"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#2   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR X3,[X2] ;
 LDR X4,[X2] | LDR X4,[X2] ;

locations [x; 0:X4; 1:X4; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+dsb.sysppte.t
dorun ./R+dsb.sysppteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+dsb.sysptepte
"DSB.SYsWWPPteOA RfePteOAPte DSB.SYsRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X2,[X0] ;
 STR X3,[X2] | LDR X3,[X0] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X3; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+dsb.sysptepte.t
dorun ./MP+dsb.sysppteoa+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+dsb.sysppte
"DSB.SYsWWPPteOA RfePteOAP DSB.SYsRRPPte FrePteP"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 STR X3,[X2] | LDR X4,[X2] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X4; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+dsb.sysppte.t
dorun ./MP+dsb.sysppteoa+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+tlbi.ishspteafp
"DSB.SYsWWPPteOA CoePteOAPteAF TLBI.ISHsWRPteAFP Fre"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X2,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; 0:X4; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+tlbi.ishspteafp.t
dorun ./R+dsb.sysppteoa+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+tlbi.ishs
"DSB.SYsWWPPteOA CoePteOAP TLBI.ISHsWR Fre"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X3,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | LDR W2,[X1]     ;

locations [x; 0:X4; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+tlbi.ishs.t
dorun ./R+dsb.sysppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+tlbi.ishsptep
"DSB.SYsWWPPteOA RfePteOAPte TLBI.ISHsRRPteP Fre"

{pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X2=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X2,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; 0:X4; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+tlbi.ishsptep.t
dorun ./MP+dsb.sysppteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+tlbi.ishs
"DSB.SYsWWPPteOA RfePteOAP TLBI.ISHsRR Fre"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X3,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X3 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR W2,[X0]     ;

locations [x; 0:X4; 1:X1; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+tlbi.ishs.t
dorun ./MP+dsb.sysppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+dsb.syspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+dsb.syspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+dsb.syspteafp
"DSB.SYsWWPPteOA CoePteOAPteAF DSB.SYsWRPteAFP Fre"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W3,[X2] ;
 STR X3,[X2] |             ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+dsb.syspteafp.t
dorun ./R+dsb.sysppteoa+dsb.syspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sysppteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sysppteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sysppteoa+dsb.sys
"DSB.SYsWWPPteOA CoePteOAP DSB.SYsWR Fre"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#2   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR W2,[X1] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sysppteoa+dsb.sys.t
dorun ./R+dsb.sysppteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+dsb.sysptep
"DSB.SYsWWPPteOA RfePteOAPte DSB.SYsRRPteP Fre"

{pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W3,[X2] ;
 STR X3,[X2] |             ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+dsb.sysptep.t
dorun ./MP+dsb.sysppteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sysppteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sysppteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sysppteoa+dsb.sys
"DSB.SYsWWPPteOA RfePteOAP DSB.SYsRR Fre"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W2,[X0] ;
 STR X3,[X2] |             ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X1; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sysppteoa+dsb.sys.t
dorun ./MP+dsb.sysppteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sysppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sysppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sysppteoas
"DSB.SYsWWPPteOA CoePteOAP DSB.SYsWWPPteOA CoePteOAP"

{pteval_t 1:X4=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#2   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;
 LDR X4,[X2] | LDR X4,[X2] ;

locations [x; 0:X4; 1:X4; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sysppteoas.t
dorun ./2+2W+dsb.sysppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoa+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoa+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoa+dsb.sysptepteoa
"DSB.SYsWWPPteOA RfePteOAPte DSB.SYsRWPtePteOA CoePteOAP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X2,[X0] ;
 STR X3,[X2] | LDR X3,[X0] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoa+dsb.sysptepteoa.t
dorun ./S+dsb.sysppteoa+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoas
"DSB.SYsWWPPteOA RfePteOAP DSB.SYsRWPPteOA CoePteOAP"

{pteval_t 1:X4=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 STR X3,[X2] | LDR X4,[X2] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoas.t
dorun ./S+dsb.sysppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sysppteoa+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sysppteoa+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sysppteoa+tlbi.ishspteafp
"DSB.SYsWWPPteOA CoePteOAPteAF TLBI.ISHsWWPteAFP Coe"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | MOV W2,#2       ;
             | STR W2,[X3]     ;

locations [x; 0:X4; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sysppteoa+tlbi.ishspteafp.t
dorun ./2+2W+dsb.sysppteoa+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sysppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sysppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sysppteoa+tlbi.ishs
"DSB.SYsWWPPteOA CoePteOAP TLBI.ISHsWW Coe"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X1=x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X3,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | MOV W2,#3       ;
             | STR W2,[X1]     ;

locations [x; 0:X4; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sysppteoa+tlbi.ishs.t
dorun ./2+2W+dsb.sysppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoa+tlbi.ishsptep
"DSB.SYsWWPPteOA RfePteOAPte TLBI.ISHsRWPteP Coe"

{pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X3,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | MOV W2,#2       ;
             | STR W2,[X3]     ;

locations [x; 0:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoa+tlbi.ishsptep.t
dorun ./S+dsb.sysppteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoa+tlbi.ishs
"DSB.SYsWWPPteOA RfePteOAP TLBI.ISHsRW Coe"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X3,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X3 ;
 LDR X4,[X2] | DSB ISH         ;
             | MOV W2,#2       ;
             | STR W2,[X0]     ;

locations [x; 0:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoa+tlbi.ishs.t
dorun ./S+dsb.sysppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sysppteoa+dsb.syspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sysppteoa+dsb.syspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sysppteoa+dsb.syspteafp
"DSB.SYsWWPPteOA CoePteOAPteAF DSB.SYsWWPteAFP Coe"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | MOV W2,#2   ;
 STR X3,[X2] | STR W2,[X3] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sysppteoa+dsb.syspteafp.t
dorun ./2+2W+dsb.sysppteoa+dsb.syspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sys+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/2+2W+dsb.sys+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sys+dsb.sysppteoa
"DSB.SYsWW Coe DSB.SYsWWPPteOA CoePteOAP"

{pteval_t 1:X4=0; y=0; 0:X1=x; 1:X1=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#3   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 MOV W2,#2   | STR X3,[X2] ;
 STR W2,[X1] | LDR X4,[X2] ;

locations [x; 1:X4; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sys+dsb.sysppteoa.t
dorun ./2+2W+dsb.sys+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoa+dsb.sysptep
"DSB.SYsWWPPteOA RfePteOAPte DSB.SYsRWPteP Coe"

{pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | MOV W2,#2   ;
 STR X3,[X2] | STR W2,[X3] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoa+dsb.sysptep.t
dorun ./S+dsb.sysppteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sysppteoa+dsb.sys.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sysppteoa+dsb.sys.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sysppteoa+dsb.sys
"DSB.SYsWWPPteOA RfePteOAP DSB.SYsRW Coe"

{pteval_t 0:X4=0; y=0; 0:X1=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | MOV W2,#2   ;
 STR X3,[X2] | STR W2,[X0] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sysppteoa+dsb.sys.t
dorun ./S+dsb.sysppteoa+dsb.sys.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafptes
"DSB.SYsWRPteAFPte FrePtePteAF DSB.SYsWRPteAFPte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 0:X3=0; pteval_t 0:X2=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 LDR X2,[X0] | LDR X2,[X0] ;
 LDR X3,[X0] | LDR X3,[X0] ;

locations [0:X3; 0:X2; 1:X3; 1:X2;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafptes.t
dorun ./SB+dsb.syspteafptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sysppte+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sysppte+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sysppte+dsb.syspteafpte
"DSB.SYsWRPPte FrePtePteAF DSB.SYsWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 0:X4=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X2,[X0] ;
 LDR X3,[X2] | LDR X3,[X0] ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 0:X3; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sysppte+dsb.syspteafpte.t
dorun ./SB+dsb.sysppte+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafpte+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafpte+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafpte+tlbi.ishspteafp
"DSB.SYsWRPteAFPte FrePtePteAF TLBI.ISHsWRPteAFP FrePPteAF"

{pteval_t 0:X3=0; pteval_t 0:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X4,X2,#12   ;
 LDR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [0:X3; 0:X2; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafpte+tlbi.ishspteafp.t
dorun ./SB+dsb.syspteafpte+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafpte+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafpte+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafpte+tlbi.ishs
"DSB.SYsWRPteAFPte FrePteP TLBI.ISHsWR FrePPteAF"

{pteval_t 0:X3=0; pteval_t 0:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X1=x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 LDR X2,[X0] | LSR X3,X1,#12   ;
 LDR X3,[X0] | DSB ISH         ;
             | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | LDR W2,[X1]     ;

locations [x; 0:X3; 0:X2; 1:X2; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafpte+tlbi.ishs.t
dorun ./SB+dsb.syspteafpte+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspteafp+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspteafp+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspteafp+dsb.syspteafpte
"DSB.SYsWRPteAFP FrePPteAF DSB.SYsWRPteAFPte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 LDR W3,[X2] | LDR X2,[X0] ;
             | LDR X3,[X0] ;

locations [0:X3; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspteafp+dsb.syspteafpte.t
dorun ./SB+dsb.syspteafp+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sys+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sys+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sys+dsb.syspteafpte
"DSB.SYsWR FrePPteAF DSB.SYsWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X2,[X0] ;
 LDR W2,[X1] | LDR X3,[X0] ;

locations [x; 0:X2; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sys+dsb.syspteafpte.t
dorun ./SB+dsb.sys+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafp+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafp+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafp+dsb.syspteafpte
"TLBI.ISHsWWPteAFP CoePPteAF DSB.SYsWRPteAFPte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | STR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR X2,[X0] ;
 TLBI VAAE1IS,X4 | LDR X3,[X0] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafp+dsb.syspteafpte.t
dorun ./R+tlbi.ishspteafp+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishs+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishs+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishs+dsb.syspteafpte
"TLBI.ISHsWW CoePPteAF DSB.SYsWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | STR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X3,X1,#12   | LDR X2,[X0] ;
 DSB ISH         | LDR X3,[X0] ;
 TLBI VAAE1IS,X3 |             ;
 DSB ISH         |             ;
 MOV W2,#2       |             ;
 STR W2,[X1]     |             ;

locations [x; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishs+dsb.syspteafpte.t
dorun ./R+tlbi.ishs+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafp+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafp+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafp+dsb.syspteafpte
"DSB.SYsWWPteAFP CoePPteAF DSB.SYsWRPteAFPte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | LDR X2,[X0] ;
 STR W2,[X3] | LDR X3,[X0] ;

locations [x; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafp+dsb.syspteafpte.t
dorun ./R+dsb.syspteafp+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sys+dsb.syspteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sys+dsb.syspteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sys+dsb.syspteafpte
"DSB.SYsWW CoePPteAF DSB.SYsWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X2=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X2,[X0] ;
 MOV W2,#2   | LDR X3,[X0] ;
 STR W2,[X1] |             ;

locations [x; 1:X3; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sys+dsb.syspteafpte.t
dorun ./R+dsb.sys+dsb.syspteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syspptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.syspptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syspptes
"DSB.SYsWRPPte FrePteP DSB.SYsWRPPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#2   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 LDR X3,[X2] | LDR X3,[X2] ;

locations [x; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syspptes.t
dorun ./SB+dsb.syspptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sysppte+tlbi.ishspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sysppte+tlbi.ishspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sysppte+tlbi.ishspteafp
"DSB.SYsWRPPte FrePtePteAF TLBI.ISHsWRPteAFP Fre"

{pteval_t 0:X4=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X4,X2,#12   ;
 DSB SY      | DSB ISH         ;
 LDR X3,[X2] | TLBI VAAE1IS,X4 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; 0:X4; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sysppte+tlbi.ishspteafp.t
dorun ./SB+dsb.sysppte+tlbi.ishspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sysppte+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sysppte+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sysppte+tlbi.ishs
"DSB.SYsWRPPte FrePteP TLBI.ISHsWR Fre"

{pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X1=x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X3,X1,#12   ;
 LDR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | LDR W2,[X1]     ;

locations [x; 0:X3; 1:X2; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sysppte+tlbi.ishs.t
dorun ./SB+dsb.sysppte+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sysppte+dsb.syspteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sysppte+dsb.syspteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sysppte+dsb.syspteafp
"DSB.SYsWRPPte FrePtePteAF DSB.SYsWRPteAFP Fre"

{pteval_t 0:X4=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_x; 1:X0=pte_x; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W3,[X2] ;
 LDR X3,[X2] |             ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sysppte+dsb.syspteafp.t
dorun ./SB+dsb.sysppte+dsb.syspteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sys+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/SB+dsb.sys+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sys+dsb.sysppte
"DSB.SYsWR Fre DSB.SYsWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#2   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 LDR W2,[X1] | LDR X3,[X2] ;

locations [x; 0:X2; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sys+dsb.sysppte.t
dorun ./SB+dsb.sys+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishspteafp+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishspteafp+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishspteafp+dsb.sysppte
"TLBI.ISHsWWPteAFP Coe DSB.SYsWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | MOV W0,#2   ;
 LSR X4,X3,#12   | STR W0,[X1] ;
 DSB ISH         | DSB SY      ;
 TLBI VAAE1IS,X4 | LDR X3,[X2] ;
 DSB ISH         | LDR X4,[X2] ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; 1:X4; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishspteafp+dsb.sysppte.t
dorun ./R+tlbi.ishspteafp+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishs+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+tlbi.ishs+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishs+dsb.sysppte
"TLBI.ISHsWW Coe DSB.SYsWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X1=x; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | MOV W0,#3   ;
 STR W0,[X1]     | STR W0,[X1] ;
 LSR X3,X1,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X3 |             ;
 DSB ISH         |             ;
 MOV W2,#2       |             ;
 STR W2,[X1]     |             ;

locations [x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishs+dsb.sysppte.t
dorun ./R+tlbi.ishs+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syspteafp+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.syspteafp+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syspteafp+dsb.sysppte
"DSB.SYsWWPteAFP Coe DSB.SYsWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | MOV W0,#2   ;
 DSB SY      | STR W0,[X1] ;
 MOV W2,#1   | DSB SY      ;
 STR W2,[X3] | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [x; 1:X4; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syspteafp+dsb.sysppte.t
dorun ./R+dsb.syspteafp+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sys+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/R+dsb.sys+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sys+dsb.sysppte
"DSB.SYsWW Coe DSB.SYsWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X1=x; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#3   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 MOV W2,#2   | LDR X3,[X2] ;
 STR W2,[X1] |             ;

locations [x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sys+dsb.sysppte.t
dorun ./R+dsb.sys+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptepteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptepteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptepteoas
"DSB.SYsRWPtePteOA RfePteOAPte DSB.SYsRWPtePteOA RfePteOAPte"

{pteval_t 1:X3=0; pteval_t 1:X1=0; pteval_t 0:X3=0; pteval_t 0:X1=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X2,[X0] | STR X2,[X0] ;
 LDR X3,[X0] | LDR X3,[X0] ;

locations [0:X3; 0:X1; 1:X3; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptepteoas.t
dorun ./LB+dsb.sysptepteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysppteoa+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysppteoa+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysppteoa+dsb.sysptepteoa
"DSB.SYsRWPPteOA RfePteOAPte DSB.SYsRWPtePteOA RfePteOAP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X2,[X0] ;
 LDR X4,[X2] | LDR X3,[X0] ;

locations [0:X4; 0:X1; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysppteoa+dsb.sysptepteoa.t
dorun ./LB+dsb.sysppteoa+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafp+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafp+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafp+dsb.sysptepteoa
"TLBI.ISHsWWPteAFP RfePPte DSB.SYsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | STR X2,[X0] ;
 TLBI VAAE1IS,X4 | LDR X3,[X0] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafp+dsb.sysptepteoa.t
dorun ./S+tlbi.ishspteafp+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishs+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishs+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishs+dsb.sysptepteoa
"TLBI.ISHsWW RfePPte DSB.SYsRWPtePteOA CoePteOAP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X3,X1,#12   | STR X2,[X0] ;
 DSB ISH         | LDR X3,[X0] ;
 TLBI VAAE1IS,X3 |             ;
 DSB ISH         |             ;
 MOV W2,#2       |             ;
 STR W2,[X1]     |             ;

locations [x; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishs+dsb.sysptepteoa.t
dorun ./S+tlbi.ishs+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptepteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptepteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptepteoa+tlbi.ishsptep
"DSB.SYsRWPtePteOA RfePteOAPte TLBI.ISHsRWPteP RfePPte"

{pteval_t 1:X1=0; pteval_t 0:X3=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 LDR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X3; 0:X1; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptepteoa+tlbi.ishsptep.t
dorun ./LB+dsb.sysptepteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptepteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptepteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptepteoa+tlbi.ishs
"DSB.SYsRWPtePteOA RfePteOAP TLBI.ISHsRW RfePPte"

{pteval_t 0:X3=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1              ;
 LDR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X3,X0,#12   ;
 STR X2,[X0] | DSB ISH         ;
 LDR X3,[X0] | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X0]     ;

locations [x; 0:X3; 0:X1; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptepteoa+tlbi.ishs.t
dorun ./LB+dsb.sysptepteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafp+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafp+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafp+dsb.sysptepteoa
"DSB.SYsWWPteAFP RfePPte DSB.SYsRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X2,[X0] ;
 STR W2,[X3] | LDR X3,[X0] ;

locations [x; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafp+dsb.sysptepteoa.t
dorun ./S+dsb.syspteafp+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sys+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sys+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sys+dsb.sysptepteoa
"DSB.SYsWW RfePPte DSB.SYsRWPtePteOA CoePteOAP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X1=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X2,[X0] ;
 MOV W2,#2   | LDR X3,[X0] ;
 STR W2,[X1] |             ;

locations [x; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sys+dsb.sysptepteoa.t
dorun ./S+dsb.sys+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysptep+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysptep+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysptep+dsb.sysptepteoa
"DSB.SYsRWPteP RfePPte DSB.SYsRWPtePteOA RfePteOAPte"

{pteval_t 1:X3=0; pteval_t 1:X1=0; pteval_t 0:X1=0; y=0; 0:X0=pte_x; 0:X3=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X2,[X0] ;
 STR W2,[X3] | LDR X3,[X0] ;

locations [x; 0:X1; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysptep+dsb.sysptepteoa.t
dorun ./LB+dsb.sysptep+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sys+dsb.sysptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sys+dsb.sysptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sys+dsb.sysptepteoa
"DSB.SYsRW RfePPte DSB.SYsRWPtePteOA RfePteOAP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X0=x; 1:X0=pte_x; pteval_t 1:X2=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X2,[X0] ;
 STR W2,[X0] | LDR X3,[X0] ;

locations [x; 0:X1; 1:X3; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sys+dsb.sysptepteoa.t
dorun ./LB+dsb.sys+dsb.sysptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysppteoas
"DSB.SYsRWPPteOA RfePteOAP DSB.SYsRWPPteOA RfePteOAP"

{pteval_t 1:X4=0; pteval_t 0:X4=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;
 LDR X4,[X2] | LDR X4,[X2] ;

locations [0:X4; 0:X1; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysppteoas.t
dorun ./LB+dsb.sysppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishspteafp+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishspteafp+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishspteafp+dsb.sysppteoa
"TLBI.ISHsWWPteAFP Rfe DSB.SYsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X4=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | STR X3,[X2] ;
 TLBI VAAE1IS,X4 | LDR X4,[X2] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishspteafp+dsb.sysppteoa.t
dorun ./S+tlbi.ishspteafp+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishs+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+tlbi.ishs+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishs+dsb.sysppteoa
"TLBI.ISHsWW Rfe DSB.SYsRWPPteOA CoePteOAP"

{pteval_t 1:X4=0; y=0; 0:X1=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X3,X1,#12   | STR X3,[X2] ;
 DSB ISH         | LDR X4,[X2] ;
 TLBI VAAE1IS,X3 |             ;
 DSB ISH         |             ;
 MOV W2,#2       |             ;
 STR W2,[X1]     |             ;

locations [x; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishs+dsb.sysppteoa.t
dorun ./S+tlbi.ishs+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysppteoa+tlbi.ishsptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysppteoa+tlbi.ishsptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysppteoa+tlbi.ishsptep
"DSB.SYsRWPPteOA RfePteOAPte TLBI.ISHsRWPteP Rfe"

{pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1              ;
 LDR W1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X4,X3,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X4; 0:X1; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysppteoa+tlbi.ishsptep.t
dorun ./LB+dsb.sysppteoa+tlbi.ishsptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysppteoa+tlbi.ishs.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysppteoa+tlbi.ishs.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysppteoa+tlbi.ishs
"DSB.SYsRWPPteOA RfePteOAP TLBI.ISHsRW Rfe"

{pteval_t 0:X4=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=x;}

 P0          | P1              ;
 LDR W1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X3,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X3 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X0]     ;

locations [x; 0:X4; 0:X1; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysppteoa+tlbi.ishs.t
dorun ./LB+dsb.sysppteoa+tlbi.ishs.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syspteafp+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.syspteafp+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syspteafp+dsb.sysppteoa
"DSB.SYsWWPteAFP Rfe DSB.SYsRWPPteOA CoePteOAPteAF"

{pteval_t 1:X4=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:0, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] | LDR X4,[X2] ;

locations [x; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syspteafp+dsb.sysppteoa.t
dorun ./S+dsb.syspteafp+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sys+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/S+dsb.sys+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sys+dsb.sysppteoa
"DSB.SYsWW Rfe DSB.SYsRWPPteOA CoePteOAP"

{pteval_t 1:X4=0; y=0; 0:X1=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 MOV W2,#2   | LDR X4,[X2] ;
 STR W2,[X1] |             ;

locations [x; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sys+dsb.sysppteoa.t
dorun ./S+dsb.sys+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sysppteoa+dsb.sysptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sysppteoa+dsb.sysptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sysppteoa+dsb.sysptep
"DSB.SYsRWPPteOA RfePteOAPte DSB.SYsRWPteP Rfe"

{pteval_t 1:X1=0; pteval_t 0:X4=0; y=0; 0:X0=x; 0:X2=pte_x; pteval_t 0:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X0=pte_x; 1:X3=x;}

 P0          | P1          ;
 LDR W1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | MOV W2,#1   ;
 LDR X4,[X2] | STR W2,[X3] ;

locations [x; 0:X4; 0:X1; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sysppteoa+dsb.sysptep.t
dorun ./LB+dsb.sysppteoa+dsb.sysptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sys+dsb.sysppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/LB+dsb.sys+dsb.sysppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sys+dsb.sysppteoa
"DSB.SYsRW Rfe DSB.SYsRWPPteOA RfePteOAP"

{pteval_t 1:X4=0; y=0; 0:X0=x; 1:X0=x; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X0] | LDR X4,[X2] ;

locations [x; 0:X1; 1:X4; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sys+dsb.sysppteoa.t
dorun ./LB+dsb.sys+dsb.sysppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafp+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafp+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafp+dsb.sysptepte
"TLBI.ISHsWWPteAFP RfePPte DSB.SYsRRPtePte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR X2,[X0] ;
 TLBI VAAE1IS,X4 | LDR X3,[X0] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; 1:X3; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafp+dsb.sysptepte.t
dorun ./MP+tlbi.ishspteafp+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishs+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishs+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishs+dsb.sysptepte
"TLBI.ISHsWW RfePPte DSB.SYsRRPtePte FrePteP"

{pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X1=x; 1:X0=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X3,X1,#12   | LDR X2,[X0] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X3 |             ;
 DSB ISH         |             ;
 MOV W2,#2       |             ;
 STR W2,[X1]     |             ;

locations [x; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishs+dsb.sysptepte.t
dorun ./MP+tlbi.ishs+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafp+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafp+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafp+dsb.sysptepte
"DSB.SYsWWPteAFP RfePPte DSB.SYsRRPtePte FrePtePteAF"

{pteval_t 1:X3=0; pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | LDR X2,[X0] ;
 STR W2,[X3] | LDR X3,[X0] ;

locations [x; 1:X3; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafp+dsb.sysptepte.t
dorun ./MP+dsb.syspteafp+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sys+dsb.sysptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sys+dsb.sysptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sys+dsb.sysptepte
"DSB.SYsWW RfePPte DSB.SYsRRPtePte FrePteP"

{pteval_t 1:X2=0; pteval_t 1:X1=0; 0:X1=x; 1:X0=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X2,[X0] ;
 MOV W2,#2   |             ;
 STR W2,[X1] |             ;

locations [x; 1:X1; 1:X2; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sys+dsb.sysptepte.t
dorun ./MP+dsb.sys+dsb.sysptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishspteafp+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishspteafp+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishspteafp+dsb.sysppte
"TLBI.ISHsWWPteAFP Rfe DSB.SYsRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X4,X3,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X4 | LDR X4,[X2] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; 1:X4; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishspteafp+dsb.sysppte.t
dorun ./MP+tlbi.ishspteafp+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishs+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+tlbi.ishs+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishs+dsb.sysppte
"TLBI.ISHsWW Rfe DSB.SYsRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X0=x; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X3,X1,#12   | LDR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X3 |             ;
 DSB ISH         |             ;
 MOV W2,#2       |             ;
 STR W2,[X1]     |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishs+dsb.sysppte.t
dorun ./MP+tlbi.ishs+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syspteafp+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.syspteafp+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syspteafp+dsb.sysppte
"DSB.SYsWWPteAFP Rfe DSB.SYsRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=x; 1:X0=x; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | LDR X3,[X2] ;
 STR W2,[X3] | LDR X4,[X2] ;

locations [x; 1:X4; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syspteafp+dsb.sysppte.t
dorun ./MP+dsb.syspteafp+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sys+dsb.sysppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/SAME/MP+dsb.sys+dsb.sysppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sys+dsb.sysppte
"DSB.SYsWW Rfe DSB.SYsRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 1:X0=x; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 MOV W2,#2   |             ;
 STR W2,[X1] |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sys+dsb.sysppte.t
dorun ./MP+dsb.sys+dsb.sysppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+tlbi.ishpteafpte
"TLBI.ISHdWWPteAFPteOA CoePteOAPteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR X3,[X2]     ;
                 | LDR X6,[X2]     ;

locations [pte_y; 1:X6; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+tlbi.ishpteafpte.t
dorun ./R+tlbi.ishpteafpteoa+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+tlbi.ishppte
"TLBI.ISHdWWPteAFPteOA CoePteOAP TLBI.ISHdWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X1=y; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | MOV W0,#1       ;
 LSR X5,X4,#12   | STR W0,[X1]     ;
 DSB ISH         | LSR X4,X1,#12   ;
 TLBI VAAE1IS,X5 | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 STR X3,[X2]     | DSB ISH         ;
                 | LDR X3,[X2]     ;
                 | LDR X5,[X2]     ;

locations [y; 1:X5; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+tlbi.ishppte.t
dorun ./R+tlbi.ishpteafpteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+tlbi.ishptepte
"TLBI.ISHdWWPteAFPteOA RfePteOAPte TLBI.ISHdRRPtePte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR X3,[X2]     ;
                 | LDR X6,[X2]     ;

locations [1:X6; 1:X1; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+tlbi.ishptepte.t
dorun ./MP+tlbi.ishpteafpteoa+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+tlbi.ishppte
"TLBI.ISHdWWPteAFPteOA RfePteOAP TLBI.ISHdRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X5,X4,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR X3,[X2]     ;
                 | LDR X5,[X2]     ;

locations [1:X5; 1:X1; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+tlbi.ishppte.t
dorun ./MP+tlbi.ishpteafpteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+dsb.sypteafpte
"TLBI.ISHdWWPteAFPteOA CoePteOAPteAF DSB.SYdWRPteAFPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | STR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X5 | LDR X4,[X2] ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [pte_y; 1:X4; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+dsb.sypteafpte.t
dorun ./R+tlbi.ishpteafpteoa+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+dsb.syppte
"TLBI.ISHdWWPteAFPteOA CoePteOAP DSB.SYdWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X1=y; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | MOV W0,#1   ;
 LSR X5,X4,#12   | STR W0,[X1] ;
 DSB ISH         | DSB SY      ;
 TLBI VAAE1IS,X5 | LDR X3,[X2] ;
 DSB ISH         | LDR X4,[X2] ;
 STR X3,[X2]     |             ;

locations [y; 1:X4; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+dsb.syppte.t
dorun ./R+tlbi.ishpteafpteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+dsb.syptepte
"TLBI.ISHdWWPteAFPteOA RfePteOAPte DSB.SYdRRPtePte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X5 | LDR X4,[X2] ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [1:X4; 1:X1; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+dsb.syptepte.t
dorun ./MP+tlbi.ishpteafpteoa+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+dsb.syppte
"TLBI.ISHdWWPteAFPteOA RfePteOAP DSB.SYdRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X5 | LDR X4,[X2] ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [1:X4; 1:X1; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+dsb.syppte.t
dorun ./MP+tlbi.ishpteafpteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+tlbi.ishpteafp
"TLBI.ISHdWWPteAFPteOA CoePteOAPteAF TLBI.ISHdWRPteAFP FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR W3,[X2]     ;

locations [pte_y; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+tlbi.ishpteafp.t
dorun ./R+tlbi.ishpteafpteoa+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+tlbi.ish
"TLBI.ISHdWWPteAFPteOA CoePteOAP TLBI.ISHdWR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X1=y; 1:X2=x;}

 P0              | P1              ;
 STR X1,[X0]     | MOV W0,#1       ;
 LSR X5,X4,#12   | STR W0,[X1]     ;
 DSB ISH         | LSR X4,X1,#12   ;
 TLBI VAAE1IS,X5 | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 STR X3,[X2]     | DSB ISH         ;
                 | LDR W3,[X2]     ;

locations [y; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+tlbi.ish.t
dorun ./R+tlbi.ishpteafpteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+tlbi.ishptep
"TLBI.ISHdWWPteAFPteOA RfePteOAPte TLBI.ISHdRRPteP FrePPteAF"

{pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X2=x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR W3,[X2]     ;

locations [1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+tlbi.ishptep.t
dorun ./MP+tlbi.ishpteafpteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+tlbi.ish
"TLBI.ISHdWWPteAFPteOA RfePteOAP TLBI.ISHdRR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X2=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X5,X4,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR W3,[X2]     ;

locations [1:X1; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+tlbi.ish.t
dorun ./MP+tlbi.ishpteafpteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+dsb.sypteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+dsb.sypteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+dsb.sypteafp
"TLBI.ISHdWWPteAFPteOA CoePteOAPteAF DSB.SYdWRPteAFP FrePPteAF"

{y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1          ;
 STR X1,[X0]     | STR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR W3,[X2] ;
 TLBI VAAE1IS,X5 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [pte_y; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+dsb.sypteafp.t
dorun ./R+tlbi.ishpteafpteoa+dsb.sypteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafpteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafpteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafpteoa+dsb.sy
"TLBI.ISHdWWPteAFPteOA CoePteOAP DSB.SYdWR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X1=y; 1:X2=x;}

 P0              | P1          ;
 STR X1,[X0]     | MOV W0,#1   ;
 LSR X5,X4,#12   | STR W0,[X1] ;
 DSB ISH         | DSB SY      ;
 TLBI VAAE1IS,X5 | LDR W3,[X2] ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [y; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafpteoa+dsb.sy.t
dorun ./R+tlbi.ishpteafpteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+dsb.syptep
"TLBI.ISHdWWPteAFPteOA RfePteOAPte DSB.SYdRRPteP FrePPteAF"

{pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X2=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR W3,[X2] ;
 TLBI VAAE1IS,X5 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+dsb.syptep.t
dorun ./MP+tlbi.ishpteafpteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafpteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafpteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafpteoa+dsb.sy
"TLBI.ISHdWWPteAFPteOA RfePteOAP DSB.SYdRR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X2=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR W3,[X2] ;
 TLBI VAAE1IS,X5 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [1:X1; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafpteoa+dsb.sy.t
dorun ./MP+tlbi.ishpteafpteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishpteafpteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+tlbi.ishpteafpteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishpteafpteoas
"TLBI.ISHdWWPteAFPteOA CoePteOAPteAF TLBI.ISHdWWPteAFPteOA CoePteOAPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;

locations [pte_y; pte_x;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishpteafpteoas.t
dorun ./2+2W+tlbi.ishpteafpteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishppteoa+tlbi.ishpteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+tlbi.ishppteoa+tlbi.ishpteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishppteoa+tlbi.ishpteafpteoa
"TLBI.ISHdWWPPteOA CoePteOAPteAF TLBI.ISHdWWPteAFPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [pte_y; x; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishppteoa+tlbi.ishpteafpteoa.t
dorun ./2+2W+tlbi.ishppteoa+tlbi.ishpteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+tlbi.ishptepteoa
"TLBI.ISHdWWPteAFPteOA RfePteOAPte TLBI.ISHdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;

locations [pte_x; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+tlbi.ishptepteoa.t
dorun ./S+tlbi.ishpteafpteoa+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+tlbi.ishppteoa
"TLBI.ISHdWWPteAFPteOA RfePteOAP TLBI.ISHdRWPPteOA CoePteOAPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X5,X4,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;

locations [pte_x; 1:X1; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+tlbi.ishppteoa.t
dorun ./S+tlbi.ishpteafpteoa+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafpteoa+tlbi.ishpteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafpteoa+tlbi.ishpteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafpteoa+tlbi.ishpteafpteoa
"DSB.SYdWWPteAFPteOA CoePteOAPteAF TLBI.ISHdWWPteAFPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_y; pte_x;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafpteoa+tlbi.ishpteafpteoa.t
dorun ./2+2W+dsb.sypteafpteoa+tlbi.ishpteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syppteoa+tlbi.ishpteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.syppteoa+tlbi.ishpteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syppteoa+tlbi.ishpteafpteoa
"DSB.SYdWWPPteOA CoePteOAPteAF TLBI.ISHdWWPteAFPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_y; x; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syppteoa+tlbi.ishpteafpteoa.t
dorun ./2+2W+dsb.syppteoa+tlbi.ishpteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+dsb.syptepteoa
"TLBI.ISHdWWPteAFPteOA RfePteOAPte DSB.SYdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | STR X3,[X2] ;
 TLBI VAAE1IS,X5 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [pte_x; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+dsb.syptepteoa.t
dorun ./S+tlbi.ishpteafpteoa+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+dsb.syppteoa
"TLBI.ISHdWWPteAFPteOA RfePteOAP DSB.SYdRWPPteOA CoePteOAPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | STR X3,[X2] ;
 TLBI VAAE1IS,X5 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [pte_x; 1:X1; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+dsb.syppteoa.t
dorun ./S+tlbi.ishpteafpteoa+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishpteafp+tlbi.ishpteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+tlbi.ishpteafp+tlbi.ishpteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishpteafp+tlbi.ishpteafpteoa
"TLBI.ISHdWWPteAFP CoePPteAF TLBI.ISHdWWPteAFPteOA CoePteOAPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [pte_x; y; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishpteafp+tlbi.ishpteafpteoa.t
dorun ./2+2W+tlbi.ishpteafp+tlbi.ishpteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ish+tlbi.ishpteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+tlbi.ish+tlbi.ishpteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ish+tlbi.ishpteafpteoa
"TLBI.ISHdWW CoePPteAF TLBI.ISHdWWPteAFPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 MOV W2,#1       |                 ;
 STR W2,[X3]     |                 ;

locations [x; y; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ish+tlbi.ishpteafpteoa.t
dorun ./2+2W+tlbi.ish+tlbi.ishpteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+tlbi.ishptep
"TLBI.ISHdWWPteAFPteOA RfePteOAPte TLBI.ISHdRWPteP CoePPteAF"

{pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X3=x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | MOV W2,#1       ;
                 | STR W2,[X3]     ;

locations [x; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+tlbi.ishptep.t
dorun ./S+tlbi.ishpteafpteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+tlbi.ish
"TLBI.ISHdWWPteAFPteOA RfePteOAP TLBI.ISHdRW CoePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X3=x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X5,X4,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | MOV W2,#1       ;
                 | STR W2,[X3]     ;

locations [x; 1:X1; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+tlbi.ish.t
dorun ./S+tlbi.ishpteafpteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafp+tlbi.ishpteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafp+tlbi.ishpteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafp+tlbi.ishpteafpteoa
"DSB.SYdWWPteAFP CoePPteAF TLBI.ISHdWWPteAFPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_x; y; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafp+tlbi.ishpteafpteoa.t
dorun ./2+2W+dsb.sypteafp+tlbi.ishpteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sy+tlbi.ishpteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sy+tlbi.ishpteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sy+tlbi.ishpteafpteoa
"DSB.SYdWW CoePPteAF TLBI.ISHdWWPteAFPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#1   | TLBI VAAE1IS,X5 ;
 STR W2,[X3] | DSB ISH         ;
             | STR X3,[X2]     ;

locations [x; y; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sy+tlbi.ishpteafpteoa.t
dorun ./2+2W+dsb.sy+tlbi.ishpteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+dsb.syptep
"TLBI.ISHdWWPteAFPteOA RfePteOAPte DSB.SYdRWPteP CoePPteAF"

{pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X3=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | MOV W2,#1   ;
 TLBI VAAE1IS,X5 | STR W2,[X3] ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+dsb.syptep.t
dorun ./S+tlbi.ishpteafpteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafpteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafpteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafpteoa+dsb.sy
"TLBI.ISHdWWPteAFPteOA RfePteOAP DSB.SYdRW CoePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=y; 1:X3=x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | MOV W2,#1   ;
 TLBI VAAE1IS,X5 | STR W2,[X3] ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafpteoa+dsb.sy.t
dorun ./S+tlbi.ishpteafpteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+tlbi.ishpteafpte
"TLBI.ISHdWWPPteOA CoePteOAPteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [pte_y; x; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+tlbi.ishpteafpte.t
dorun ./R+tlbi.ishppteoa+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+tlbi.ishppte
"TLBI.ISHdWWPPteOA CoePteOAP TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#1       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR X3,[X2]     ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+tlbi.ishppte.t
dorun ./R+tlbi.ishppteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+tlbi.ishptepte
"TLBI.ISHdWWPPteOA RfePteOAPte TLBI.ISHdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [x; 1:X1; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+tlbi.ishptepte.t
dorun ./MP+tlbi.ishppteoa+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+tlbi.ishppte
"TLBI.ISHdWWPPteOA RfePteOAP TLBI.ISHdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+tlbi.ishppte.t
dorun ./MP+tlbi.ishppteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+dsb.sypteafpte
"TLBI.ISHdWWPPteOA CoePteOAPteAF DSB.SYdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | STR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [pte_y; x; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+dsb.sypteafpte.t
dorun ./R+tlbi.ishppteoa+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+dsb.syppte
"TLBI.ISHdWWPPteOA CoePteOAP DSB.SYdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | MOV W0,#1   ;
 STR W0,[X1]     | STR W0,[X1] ;
 LSR X4,X1,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+dsb.syppte.t
dorun ./R+tlbi.ishppteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+dsb.syptepte
"TLBI.ISHdWWPPteOA RfePteOAPte DSB.SYdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+dsb.syptepte.t
dorun ./MP+tlbi.ishppteoa+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+dsb.syppte
"TLBI.ISHdWWPPteOA RfePteOAP DSB.SYdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+dsb.syppte.t
dorun ./MP+tlbi.ishppteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+tlbi.ishpteafp
"TLBI.ISHdWWPPteOA CoePteOAPteAF TLBI.ISHdWRPteAFP Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [pte_y; x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+tlbi.ishpteafp.t
dorun ./R+tlbi.ishppteoa+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+tlbi.ish
"TLBI.ISHdWWPPteOA CoePteOAP TLBI.ISHdWR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#1       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | LDR W3,[X2]     ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+tlbi.ish.t
dorun ./R+tlbi.ishppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+tlbi.ishptep
"TLBI.ISHdWWPPteOA RfePteOAPte TLBI.ISHdRRPteP Fre"

{pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+tlbi.ishptep.t
dorun ./MP+tlbi.ishppteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+tlbi.ish
"TLBI.ISHdWWPPteOA RfePteOAP TLBI.ISHdRR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=x;}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+tlbi.ish.t
dorun ./MP+tlbi.ishppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+dsb.sypteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+dsb.sypteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+dsb.sypteafp
"TLBI.ISHdWWPPteOA CoePteOAPteAF DSB.SYdWRPteAFP Fre"

{y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0              | P1          ;
 MOV W0,#1       | STR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR W3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [pte_y; x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+dsb.sypteafp.t
dorun ./R+tlbi.ishppteoa+dsb.sypteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishppteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishppteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishppteoa+dsb.sy
"TLBI.ISHdWWPPteOA CoePteOAP DSB.SYdWR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=x;}

 P0              | P1          ;
 MOV W0,#1       | MOV W0,#1   ;
 STR W0,[X1]     | STR W0,[X1] ;
 LSR X4,X1,#12   | DSB SY      ;
 DSB ISH         | LDR W3,[X2] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishppteoa+dsb.sy.t
dorun ./R+tlbi.ishppteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+dsb.syptep
"TLBI.ISHdWWPPteOA RfePteOAPte DSB.SYdRRPteP Fre"

{pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=x;}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR W3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+dsb.syptep.t
dorun ./MP+tlbi.ishppteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishppteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishppteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishppteoa+dsb.sy
"TLBI.ISHdWWPPteOA RfePteOAP DSB.SYdRR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=x;}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR W3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishppteoa+dsb.sy.t
dorun ./MP+tlbi.ishppteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+tlbi.ishppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishppteoas
"TLBI.ISHdWWPPteOA CoePteOAP TLBI.ISHdWWPPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#1       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;

locations [x; y; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishppteoas.t
dorun ./2+2W+tlbi.ishppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoa+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoa+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoa+tlbi.ishptepteoa
"TLBI.ISHdWWPPteOA RfePteOAPte TLBI.ISHdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [x; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoa+tlbi.ishptepteoa.t
dorun ./S+tlbi.ishppteoa+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoas
"TLBI.ISHdWWPPteOA RfePteOAP TLBI.ISHdRWPPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 STR X3,[X2]     |                 ;

locations [x; 1:X1; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoas.t
dorun ./S+tlbi.ishppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafpteoa+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafpteoa+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafpteoa+tlbi.ishppteoa
"DSB.SYdWWPteAFPteOA CoePteOAP TLBI.ISHdWWPPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_x; y; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafpteoa+tlbi.ishppteoa.t
dorun ./2+2W+dsb.sypteafpteoa+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syppteoa+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.syppteoa+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syppteoa+tlbi.ishppteoa
"DSB.SYdWWPPteOA CoePteOAP TLBI.ISHdWWPPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#1       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [x; y; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syppteoa+tlbi.ishppteoa.t
dorun ./2+2W+dsb.syppteoa+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoa+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoa+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoa+dsb.syptepteoa
"TLBI.ISHdWWPPteOA RfePteOAPte DSB.SYdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | STR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoa+dsb.syptepteoa.t
dorun ./S+tlbi.ishppteoa+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoa+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoa+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoa+dsb.syppteoa
"TLBI.ISHdWWPPteOA RfePteOAP DSB.SYdRWPPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | STR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoa+dsb.syppteoa.t
dorun ./S+tlbi.ishppteoa+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ishppteoa+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+tlbi.ishppteoa+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ishppteoa+tlbi.ishpteafp
"TLBI.ISHdWWPPteOA CoePteOAPteAF TLBI.ISHdWWPteAFP Coe"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#2       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | MOV W2,#1       ;
 STR X3,[X2]     | STR W2,[X3]     ;

locations [pte_y; x; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ishppteoa+tlbi.ishpteafp.t
dorun ./2+2W+tlbi.ishppteoa+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+tlbi.ish+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+tlbi.ish+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+tlbi.ish+tlbi.ishppteoa
"TLBI.ISHdWW Coe TLBI.ISHdWWPPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#2       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [x; y; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+tlbi.ish+tlbi.ishppteoa.t
dorun ./2+2W+tlbi.ish+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoa+tlbi.ishptep
"TLBI.ISHdWWPPteOA RfePteOAPte TLBI.ISHdRWPteP Coe"

{pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#2       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | MOV W2,#1       ;
 STR X3,[X2]     | STR W2,[X3]     ;

locations [x; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoa+tlbi.ishptep.t
dorun ./S+tlbi.ishppteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoa+tlbi.ish
"TLBI.ISHdWWPPteOA RfePteOAP TLBI.ISHdRW Coe"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0              | P1              ;
 MOV W0,#2       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | MOV W2,#1       ;
 STR X3,[X2]     | STR W2,[X3]     ;

locations [x; 1:X1; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoa+tlbi.ish.t
dorun ./S+tlbi.ishppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafp+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafp+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafp+tlbi.ishppteoa
"DSB.SYdWWPteAFP Coe TLBI.ISHdWWPPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#2       ;
 DSB SY      | STR W0,[X1]     ;
 MOV W2,#1   | LSR X4,X1,#12   ;
 STR W2,[X3] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_x; y; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafp+tlbi.ishppteoa.t
dorun ./2+2W+dsb.sypteafp+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sy+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sy+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sy+tlbi.ishppteoa
"DSB.SYdWW Coe TLBI.ISHdWWPPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [x; y; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sy+tlbi.ishppteoa.t
dorun ./2+2W+dsb.sy+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoa+dsb.syptep
"TLBI.ISHdWWPPteOA RfePteOAPte DSB.SYdRWPteP Coe"

{pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x;}

 P0              | P1          ;
 MOV W0,#2       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | MOV W2,#1   ;
 DSB ISH         | STR W2,[X3] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoa+dsb.syptep.t
dorun ./S+tlbi.ishppteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishppteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishppteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishppteoa+dsb.sy
"TLBI.ISHdWWPPteOA RfePteOAP DSB.SYdRW Coe"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0              | P1          ;
 MOV W0,#2       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | MOV W2,#1   ;
 DSB ISH         | STR W2,[X3] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 STR X3,[X2]     |             ;

locations [x; 1:X1; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishppteoa+dsb.sy.t
dorun ./S+tlbi.ishppteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishpteafptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+tlbi.ishpteafptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishpteafptes
"TLBI.ISHdWRPteAFPte FrePtePteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; pteval_t 0:X6=0; pteval_t 0:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 LDR X3,[X2]     | LDR X3,[X2]     ;
 LDR X6,[X2]     | LDR X6,[X2]     ;

locations [0:X6; 0:X3; 1:X6; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishpteafptes.t
dorun ./SB+tlbi.ishpteafptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishppte+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+tlbi.ishppte+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishppte+tlbi.ishpteafpte
"TLBI.ISHdWRPPte FrePtePteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X5=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 LDR X3,[X2]     |                 ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 0:X3; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishppte+tlbi.ishpteafpte.t
dorun ./SB+tlbi.ishppte+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafpte+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafpte+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafpte+tlbi.ishpteafpte
"DSB.SYdWRPteAFPte FrePtePteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; pteval_t 0:X4=0; pteval_t 0:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 LDR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X6,[X2]     ;

locations [0:X4; 0:X3; 1:X6; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafpte+tlbi.ishpteafpte.t
dorun ./SB+dsb.sypteafpte+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syppte+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.syppte+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syppte+tlbi.ishpteafpte
"DSB.SYdWRPPte FrePtePteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X4=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 LDR X3,[X2] | TLBI VAAE1IS,X5 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 0:X4; 0:X3; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syppte+tlbi.ishpteafpte.t
dorun ./SB+dsb.syppte+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishpteafp+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+tlbi.ishpteafp+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishpteafp+tlbi.ishpteafpte
"TLBI.ISHdWRPteAFP FrePPteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=y; 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 LDR W3,[X2]     | LDR X3,[X2]     ;
                 | LDR X6,[X2]     ;

locations [0:X3; 1:X6; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishpteafp+tlbi.ishpteafpte.t
dorun ./SB+tlbi.ishpteafp+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ish+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+tlbi.ish+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ish+tlbi.ishpteafpte
"TLBI.ISHdWR FrePPteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 LDR W3,[X2]     |                 ;

locations [x; 0:X3; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ish+tlbi.ishpteafpte.t
dorun ./SB+tlbi.ish+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafp+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafp+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafp+tlbi.ishpteafpte
"DSB.SYdWRPteAFP FrePPteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 LDR W3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X6,[X2]     ;

locations [0:X3; 1:X6; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafp+tlbi.ishpteafpte.t
dorun ./SB+dsb.sypteafp+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sy+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sy+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sy+tlbi.ishpteafpte
"DSB.SYdWR FrePPteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 LDR W3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 0:X3; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sy+tlbi.ishpteafpte.t
dorun ./SB+dsb.sy+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+tlbi.ishpteafpte
"DSB.SYdWWPteAFPteOA CoePteOAPteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X6,[X2]     ;

locations [pte_y; 1:X6; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+tlbi.ishpteafpte.t
dorun ./R+dsb.sypteafpteoa+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+tlbi.ishpteafpte
"DSB.SYdWWPPteOA CoePteOAPteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [pte_y; x; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+tlbi.ishpteafpte.t
dorun ./R+dsb.syppteoa+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafp+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafp+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafp+tlbi.ishpteafpte
"TLBI.ISHdWWPteAFP CoePPteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | STR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | LDR X3,[X2]     ;
 STR W2,[X3]     | LDR X6,[X2]     ;

locations [y; 1:X6; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafp+tlbi.ishpteafpte.t
dorun ./R+tlbi.ishpteafp+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ish+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ish+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ish+tlbi.ishpteafpte
"TLBI.ISHdWW CoePPteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 MOV W2,#1       |                 ;
 STR W2,[X3]     |                 ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ish+tlbi.ishpteafpte.t
dorun ./R+tlbi.ish+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafp+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafp+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafp+tlbi.ishpteafpte
"DSB.SYdWWPteAFP CoePPteAF TLBI.ISHdWRPteAFPte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X6,[X2]     ;

locations [y; 1:X6; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafp+tlbi.ishpteafpte.t
dorun ./R+dsb.sypteafp+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sy+tlbi.ishpteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sy+tlbi.ishpteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sy+tlbi.ishpteafpte
"DSB.SYdWW CoePPteAF TLBI.ISHdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#1   | TLBI VAAE1IS,X5 ;
 STR W2,[X3] | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sy+tlbi.ishpteafpte.t
dorun ./R+dsb.sy+tlbi.ishpteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishpptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+tlbi.ishpptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishpptes
"TLBI.ISHdWRPPte FrePteP TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X1=y; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#1       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 LDR X3,[X2]     | LDR X3,[X2]     ;

locations [x; y; 0:X3; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishpptes.t
dorun ./SB+tlbi.ishpptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafpte+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafpte+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafpte+tlbi.ishppte
"DSB.SYdWRPteAFPte FrePteP TLBI.ISHdWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; pteval_t 0:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 LDR X3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [y; 0:X3; 1:X5; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafpte+tlbi.ishppte.t
dorun ./SB+dsb.sypteafpte+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syppte+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.syppte+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syppte+tlbi.ishppte
"DSB.SYdWRPPte FrePteP TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#1       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 LDR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; y; 0:X3; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syppte+tlbi.ishppte.t
dorun ./SB+dsb.syppte+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ishppte+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+tlbi.ishppte+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ishppte+tlbi.ishpteafp
"TLBI.ISHdWRPPte FrePtePteAF TLBI.ISHdWRPteAFP Fre"

{pteval_t 0:X5=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | STR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR W3,[X2]     ;
 LDR X3,[X2]     |                 ;
 LDR X5,[X2]     |                 ;

locations [x; 0:X5; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ishppte+tlbi.ishpteafp.t
dorun ./SB+tlbi.ishppte+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+tlbi.ish+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+tlbi.ish+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+tlbi.ish+tlbi.ishppte
"TLBI.ISHdWR Fre TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=y; 1:X1=y; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#1       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 LDR W3,[X2]     | LDR X3,[X2]     ;

locations [x; y; 0:X3; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+tlbi.ish+tlbi.ishppte.t
dorun ./SB+tlbi.ish+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafp+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafp+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafp+tlbi.ishppte
"DSB.SYdWRPteAFP Fre TLBI.ISHdWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 LDR W3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [y; 0:X3; 1:X5; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafp+tlbi.ishppte.t
dorun ./SB+dsb.sypteafp+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sy+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sy+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sy+tlbi.ishppte
"DSB.SYdWR Fre TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#1       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 LDR W3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; y; 0:X3; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sy+tlbi.ishppte.t
dorun ./SB+dsb.sy+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+tlbi.ishppte
"DSB.SYdWWPteAFPteOA CoePteOAP TLBI.ISHdWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [y; 1:X5; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+tlbi.ishppte.t
dorun ./R+dsb.sypteafpteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+tlbi.ishppte
"DSB.SYdWWPPteOA CoePteOAP TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#1       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+tlbi.ishppte.t
dorun ./R+dsb.syppteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafp+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafp+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafp+tlbi.ishppte
"TLBI.ISHdWWPteAFP Coe TLBI.ISHdWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X1=y; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | MOV W0,#2       ;
 LSR X5,X4,#12   | STR W0,[X1]     ;
 DSB ISH         | LSR X4,X1,#12   ;
 TLBI VAAE1IS,X5 | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 MOV W2,#1       | DSB ISH         ;
 STR W2,[X3]     | LDR X3,[X2]     ;
                 | LDR X5,[X2]     ;

locations [y; 1:X5; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafp+tlbi.ishppte.t
dorun ./R+tlbi.ishpteafp+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ish+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ish+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ish+tlbi.ishppte
"TLBI.ISHdWW Coe TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X1=y; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | MOV W0,#2       ;
 STR W0,[X1]     | STR W0,[X1]     ;
 LSR X4,X1,#12   | LSR X4,X1,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | LDR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ish+tlbi.ishppte.t
dorun ./R+tlbi.ish+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafp+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafp+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafp+tlbi.ishppte
"DSB.SYdWWPteAFP Coe TLBI.ISHdWRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#2       ;
 DSB SY      | STR W0,[X1]     ;
 MOV W2,#1   | LSR X4,X1,#12   ;
 STR W2,[X3] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [y; 1:X5; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafp+tlbi.ishppte.t
dorun ./R+dsb.sypteafp+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sy+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sy+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sy+tlbi.ishppte
"DSB.SYdWW Coe TLBI.ISHdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#2       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sy+tlbi.ishppte.t
dorun ./R+dsb.sy+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishptepteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+tlbi.ishptepteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishptepteoas
"TLBI.ISHdRWPtePteOA RfePteOAPte TLBI.ISHdRWPtePteOA RfePteOAPte"

{pteval_t 1:X1=0; pteval_t 0:X1=0; 0:X0=pte_x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 LDR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;

locations [0:X1; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishptepteoas.t
dorun ./LB+tlbi.ishptepteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishppteoa+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+tlbi.ishppteoa+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishppteoa+tlbi.ishptepteoa
"TLBI.ISHdRWPPteOA RfePteOAPte TLBI.ISHdRWPtePteOA RfePteOAP"

{pteval_t 1:X1=0; 0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 LDR W1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X0,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;

locations [0:X1; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishppteoa+tlbi.ishptepteoa.t
dorun ./LB+tlbi.ishppteoa+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+tlbi.ishptepteoa
"DSB.SYdWWPteAFPteOA RfePteOAPte TLBI.ISHdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_x; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+tlbi.ishptepteoa.t
dorun ./S+dsb.sypteafpteoa+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoa+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoa+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoa+tlbi.ishptepteoa
"DSB.SYdWWPPteOA RfePteOAPte TLBI.ISHdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [x; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoa+tlbi.ishptepteoa.t
dorun ./S+dsb.syppteoa+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptepteoa+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptepteoa+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptepteoa+tlbi.ishptepteoa
"DSB.SYdRWPtePteOA RfePteOAPte TLBI.ISHdRWPtePteOA RfePteOAPte"

{pteval_t 1:X1=0; pteval_t 0:X1=0; x=0; 0:X0=pte_x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 LDR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [0:X1; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptepteoa+tlbi.ishptepteoa.t
dorun ./LB+dsb.syptepteoa+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syppteoa+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syppteoa+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syppteoa+tlbi.ishptepteoa
"DSB.SYdRWPPteOA RfePteOAPte TLBI.ISHdRWPtePteOA RfePteOAP"

{pteval_t 1:X1=0; 0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 LDR W1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [0:X1; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syppteoa+tlbi.ishptepteoa.t
dorun ./LB+dsb.syppteoa+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafp+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafp+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafp+tlbi.ishptepteoa
"TLBI.ISHdWWPteAFP RfePPte TLBI.ISHdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [pte_x; y; 1:X1; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafp+tlbi.ishptepteoa.t
dorun ./S+tlbi.ishpteafp+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ish+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ish+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ish+tlbi.ishptepteoa
"TLBI.ISHdWW RfePPte TLBI.ISHdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 MOV W2,#1       |                 ;
 STR W2,[X3]     |                 ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ish+tlbi.ishptepteoa.t
dorun ./S+tlbi.ish+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishptep+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+tlbi.ishptep+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishptep+tlbi.ishptepteoa
"TLBI.ISHdRWPteP RfePPte TLBI.ISHdRWPtePteOA RfePteOAPte"

{pteval_t 1:X1=0; pteval_t 0:X1=0; 0:X0=pte_x; 0:X3=y; 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 LDR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [y; 0:X1; 1:X1; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishptep+tlbi.ishptepteoa.t
dorun ./LB+tlbi.ishptep+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ish+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+tlbi.ish+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ish+tlbi.ishptepteoa
"TLBI.ISHdRW RfePPte TLBI.ISHdRWPtePteOA RfePteOAP"

{pteval_t 1:X1=0; 0:X0=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0              | P1              ;
 LDR W1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X0,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [y; 0:X1; 1:X1; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ish+tlbi.ishptepteoa.t
dorun ./LB+tlbi.ish+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafp+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafp+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafp+tlbi.ishptepteoa
"DSB.SYdWWPteAFP RfePPte TLBI.ISHdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_x; y; 1:X1; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafp+tlbi.ishptepteoa.t
dorun ./S+dsb.sypteafp+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sy+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sy+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sy+tlbi.ishptepteoa
"DSB.SYdWW RfePPte TLBI.ISHdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#1   | TLBI VAAE1IS,X5 ;
 STR W2,[X3] | DSB ISH         ;
             | STR X3,[X2]     ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sy+tlbi.ishptepteoa.t
dorun ./S+dsb.sy+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptep+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptep+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptep+tlbi.ishptepteoa
"DSB.SYdRWPteP RfePPte TLBI.ISHdRWPtePteOA RfePteOAPte"

{pteval_t 1:X1=0; pteval_t 0:X1=0; x=0; 0:X0=pte_x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 LDR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [y; 0:X1; 1:X1; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptep+tlbi.ishptepteoa.t
dorun ./LB+dsb.syptep+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sy+tlbi.ishptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.sy+tlbi.ishptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sy+tlbi.ishptepteoa
"DSB.SYdRW RfePPte TLBI.ISHdRWPtePteOA RfePteOAP"

{pteval_t 1:X1=0; 0:X0=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1); 1:X4=y;}

 P0          | P1              ;
 LDR W1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [y; 0:X1; 1:X1; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sy+tlbi.ishptepteoa.t
dorun ./LB+dsb.sy+tlbi.ishptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+tlbi.ishppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishppteoas
"TLBI.ISHdRWPPteOA RfePteOAP TLBI.ISHdRWPPteOA RfePteOAP"

{0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 LDR W1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X0,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | STR X3,[X2]     ;

locations [0:X1; 1:X1; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishppteoas.t
dorun ./LB+tlbi.ishppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+tlbi.ishppteoa
"DSB.SYdWWPteAFPteOA RfePteOAP TLBI.ISHdRWPPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_x; 1:X1; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+tlbi.ishppteoa.t
dorun ./S+dsb.sypteafpteoa+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoa+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoa+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoa+tlbi.ishppteoa
"DSB.SYdWWPPteOA RfePteOAP TLBI.ISHdRWPPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [x; 1:X1; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoa+tlbi.ishppteoa.t
dorun ./S+dsb.syppteoa+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptepteoa+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptepteoa+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptepteoa+tlbi.ishppteoa
"DSB.SYdRWPtePteOA RfePteOAP TLBI.ISHdRWPPteOA RfePteOAPte"

{pteval_t 0:X1=0; x=0; 0:X0=pte_x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [0:X1; 1:X1; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptepteoa+tlbi.ishppteoa.t
dorun ./LB+dsb.syptepteoa+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syppteoa+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syppteoa+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syppteoa+tlbi.ishppteoa
"DSB.SYdRWPPteOA RfePteOAP TLBI.ISHdRWPPteOA RfePteOAP"

{0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR W1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [0:X1; 1:X1; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syppteoa+tlbi.ishppteoa.t
dorun ./LB+dsb.syppteoa+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafp+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafp+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafp+tlbi.ishppteoa
"TLBI.ISHdWWPteAFP Rfe TLBI.ISHdRWPPteOA CoePteOAPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X5,X4,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [pte_x; y; 1:X1; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafp+tlbi.ishppteoa.t
dorun ./S+tlbi.ishpteafp+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ish+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ish+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ish+tlbi.ishppteoa
"TLBI.ISHdWW Rfe TLBI.ISHdRWPPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | STR X3,[X2]     ;
 MOV W2,#1       |                 ;
 STR W2,[X3]     |                 ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ish+tlbi.ishppteoa.t
dorun ./S+tlbi.ish+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ishppteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+tlbi.ishppteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ishppteoa+tlbi.ishptep
"TLBI.ISHdRWPPteOA RfePteOAPte TLBI.ISHdRWPteP Rfe"

{pteval_t 1:X1=0; 0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x; 1:X4=y;}

 P0              | P1              ;
 LDR W1,[X0]     | LDR X1,[X0]     ;
 LSR X4,X0,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 STR X3,[X2]     | MOV W2,#1       ;
                 | STR W2,[X3]     ;

locations [x; 0:X1; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ishppteoa+tlbi.ishptep.t
dorun ./LB+tlbi.ishppteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+tlbi.ish+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+tlbi.ish+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+tlbi.ish+tlbi.ishppteoa
"TLBI.ISHdRW Rfe TLBI.ISHdRWPPteOA RfePteOAP"

{0:X0=x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1              ;
 LDR W1,[X0]     | LDR W1,[X0]     ;
 LSR X4,X0,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X4 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | STR X3,[X2]     ;
 STR W2,[X3]     |                 ;

locations [y; 0:X1; 1:X1; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+tlbi.ish+tlbi.ishppteoa.t
dorun ./LB+tlbi.ish+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafp+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafp+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafp+tlbi.ishppteoa
"DSB.SYdWWPteAFP Rfe TLBI.ISHdRWPPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [pte_x; y; 1:X1; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafp+tlbi.ishppteoa.t
dorun ./S+dsb.sypteafp+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sy+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sy+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sy+tlbi.ishppteoa
"DSB.SYdWW Rfe TLBI.ISHdRWPPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#1   | TLBI VAAE1IS,X4 ;
 STR W2,[X3] | DSB ISH         ;
             | STR X3,[X2]     ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sy+tlbi.ishppteoa.t
dorun ./S+dsb.sy+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptep+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptep+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptep+tlbi.ishppteoa
"DSB.SYdRWPteP Rfe TLBI.ISHdRWPPteOA RfePteOAPte"

{pteval_t 0:X1=0; x=0; 0:X0=pte_x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [y; 0:X1; 1:X1; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptep+tlbi.ishppteoa.t
dorun ./LB+dsb.syptep+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sy+tlbi.ishppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.sy+tlbi.ishppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sy+tlbi.ishppteoa
"DSB.SYdRW Rfe TLBI.ISHdRWPPteOA RfePteOAP"

{0:X0=x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1              ;
 LDR W1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | STR X3,[X2]     ;

locations [y; 0:X1; 1:X1; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sy+tlbi.ishppteoa.t
dorun ./LB+dsb.sy+tlbi.ishppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+tlbi.ishptepte
"DSB.SYdWWPteAFPteOA RfePteOAPte TLBI.ISHdRRPtePte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; pteval_t 1:X1=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X6,[X2]     ;

locations [1:X6; 1:X1; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+tlbi.ishptepte.t
dorun ./MP+dsb.sypteafpteoa+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+tlbi.ishptepte
"DSB.SYdWWPPteOA RfePteOAPte TLBI.ISHdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 1:X1; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+tlbi.ishptepte.t
dorun ./MP+dsb.syppteoa+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafp+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafp+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafp+tlbi.ishptepte
"TLBI.ISHdWWPteAFP RfePPte TLBI.ISHdRRPtePte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 STR X1,[X0]     | LDR X1,[X0]     ;
 LSR X5,X4,#12   | LSR X5,X4,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X5 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | LDR X3,[X2]     ;
 STR W2,[X3]     | LDR X6,[X2]     ;

locations [y; 1:X6; 1:X1; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafp+tlbi.ishptepte.t
dorun ./MP+tlbi.ishpteafp+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ish+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ish+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ish+tlbi.ishptepte
"TLBI.ISHdWW RfePPte TLBI.ISHdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0              | P1              ;
 MOV W0,#1       | LDR X1,[X0]     ;
 STR W0,[X1]     | LSR X5,X4,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X5 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 MOV W2,#1       |                 ;
 STR W2,[X3]     |                 ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ish+tlbi.ishptepte.t
dorun ./MP+tlbi.ish+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafp+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafp+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafp+tlbi.ishptepte
"DSB.SYdWWPteAFP RfePPte TLBI.ISHdRRPtePte FrePtePteAF"

{pteval_t 1:X6=0; pteval_t 1:X3=0; pteval_t 1:X1=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X6,[X2]     ;

locations [y; 1:X6; 1:X1; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafp+tlbi.ishptepte.t
dorun ./MP+dsb.sypteafp+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sy+tlbi.ishptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sy+tlbi.ishptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sy+tlbi.ishptepte
"DSB.SYdWW RfePPte TLBI.ISHdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#1   | TLBI VAAE1IS,X5 ;
 STR W2,[X3] | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sy+tlbi.ishptepte.t
dorun ./MP+dsb.sy+tlbi.ishptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+tlbi.ishppte
"DSB.SYdWWPteAFPteOA RfePteOAP TLBI.ISHdRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [1:X5; 1:X1; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+tlbi.ishppte.t
dorun ./MP+dsb.sypteafpteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+tlbi.ishppte
"DSB.SYdWWPPteOA RfePteOAP TLBI.ISHdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+tlbi.ishppte.t
dorun ./MP+dsb.syppteoa+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafp+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafp+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafp+tlbi.ishppte
"TLBI.ISHdWWPteAFP Rfe TLBI.ISHdRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=y; 1:X2=pte_x;}

 P0              | P1              ;
 STR X1,[X0]     | LDR W1,[X0]     ;
 LSR X5,X4,#12   | LSR X4,X0,#12   ;
 DSB ISH         | DSB ISH         ;
 TLBI VAAE1IS,X5 | TLBI VAAE1IS,X4 ;
 DSB ISH         | DSB ISH         ;
 MOV W2,#1       | LDR X3,[X2]     ;
 STR W2,[X3]     | LDR X5,[X2]     ;

locations [y; 1:X5; 1:X1; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafp+tlbi.ishppte.t
dorun ./MP+tlbi.ishpteafp+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ish+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ish+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ish+tlbi.ishppte
"TLBI.ISHdWW Rfe TLBI.ISHdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x;}

 P0              | P1              ;
 MOV W0,#1       | LDR W1,[X0]     ;
 STR W0,[X1]     | LSR X4,X0,#12   ;
 LSR X4,X1,#12   | DSB ISH         ;
 DSB ISH         | TLBI VAAE1IS,X4 ;
 TLBI VAAE1IS,X4 | DSB ISH         ;
 DSB ISH         | LDR X3,[X2]     ;
 MOV W2,#1       |                 ;
 STR W2,[X3]     |                 ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ish+tlbi.ishppte.t
dorun ./MP+tlbi.ish+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafp+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafp+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafp+tlbi.ishppte
"DSB.SYdWWPteAFP Rfe TLBI.ISHdRRPPte FrePtePteAF"

{pteval_t 1:X5=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=y; 1:X2=pte_x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 MOV W2,#1   | DSB ISH         ;
 STR W2,[X3] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR X3,[X2]     ;
             | LDR X5,[X2]     ;

locations [y; 1:X5; 1:X1; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafp+tlbi.ishppte.t
dorun ./MP+dsb.sypteafp+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sy+tlbi.ishppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sy+tlbi.ishppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sy+tlbi.ishppte
"DSB.SYdWW Rfe TLBI.ISHdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x;}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 MOV W2,#1   | TLBI VAAE1IS,X4 ;
 STR W2,[X3] | DSB ISH         ;
             | LDR X3,[X2]     ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sy+tlbi.ishppte.t
dorun ./MP+dsb.sy+tlbi.ishppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+dsb.sypteafpte
"DSB.SYdWWPteAFPteOA CoePteOAPteAF DSB.SYdWRPteAFPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [pte_y; 1:X4; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+dsb.sypteafpte.t
dorun ./R+dsb.sypteafpteoa+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+dsb.syppte
"DSB.SYdWWPteAFPteOA CoePteOAP DSB.SYdWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | MOV W0,#1   ;
 DSB SY      | STR W0,[X1] ;
 STR X3,[X2] | DSB SY      ;
             | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [y; 1:X4; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+dsb.syppte.t
dorun ./R+dsb.sypteafpteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+dsb.syptepte
"DSB.SYdWWPteAFPteOA RfePteOAPte DSB.SYdRRPtePte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [1:X4; 1:X1; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+dsb.syptepte.t
dorun ./MP+dsb.sypteafpteoa+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+dsb.syppte
"DSB.SYdWWPteAFPteOA RfePteOAP DSB.SYdRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [1:X4; 1:X1; 1:X3; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+dsb.syppte.t
dorun ./MP+dsb.sypteafpteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+tlbi.ishpteafp
"DSB.SYdWWPteAFPteOA CoePteOAPteAF TLBI.ISHdWRPteAFP FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [pte_y; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+tlbi.ishpteafp.t
dorun ./R+dsb.sypteafpteoa+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+tlbi.ish
"DSB.SYdWWPteAFPteOA CoePteOAP TLBI.ISHdWR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [y; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+tlbi.ish.t
dorun ./R+dsb.sypteafpteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+tlbi.ishptep
"DSB.SYdWWPteAFPteOA RfePteOAPte TLBI.ISHdRRPteP FrePPteAF"

{pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+tlbi.ishptep.t
dorun ./MP+dsb.sypteafpteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+tlbi.ish
"DSB.SYdWWPteAFPteOA RfePteOAP TLBI.ISHdRR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [1:X1; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+tlbi.ish.t
dorun ./MP+dsb.sypteafpteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+dsb.sypteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+dsb.sypteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+dsb.sypteafp
"DSB.SYdWWPteAFPteOA CoePteOAPteAF DSB.SYdWRPteAFP FrePPteAF"

{y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR W3,[X2] ;

locations [pte_y; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+dsb.sypteafp.t
dorun ./R+dsb.sypteafpteoa+dsb.sypteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafpteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafpteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafpteoa+dsb.sy
"DSB.SYdWWPteAFPteOA CoePteOAP DSB.SYdWR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=x;}

 P0          | P1          ;
 STR X1,[X0] | MOV W0,#1   ;
 DSB SY      | STR W0,[X1] ;
 STR X3,[X2] | DSB SY      ;
             | LDR W3,[X2] ;

locations [y; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafpteoa+dsb.sy.t
dorun ./R+dsb.sypteafpteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+dsb.syptep
"DSB.SYdWWPteAFPteOA RfePteOAPte DSB.SYdRRPteP FrePPteAF"

{pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR W3,[X2] ;

locations [1:X1; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+dsb.syptep.t
dorun ./MP+dsb.sypteafpteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafpteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafpteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafpteoa+dsb.sy
"DSB.SYdWWPteAFPteOA RfePteOAP DSB.SYdRR FrePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR W3,[X2] ;

locations [1:X1; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafpteoa+dsb.sy.t
dorun ./MP+dsb.sypteafpteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafpteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafpteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafpteoas
"DSB.SYdWWPteAFPteOA CoePteOAPteAF DSB.SYdWWPteAFPteOA CoePteOAPteAF"

{y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;

locations [pte_y; pte_x;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafpteoas.t
dorun ./2+2W+dsb.sypteafpteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syppteoa+dsb.sypteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.syppteoa+dsb.sypteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syppteoa+dsb.sypteafpteoa
"DSB.SYdWWPPteOA CoePteOAPteAF DSB.SYdWWPteAFPteOA CoePteOAP"

{y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 STR X3,[X2] |             ;

locations [pte_y; x; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syppteoa+dsb.sypteafpteoa.t
dorun ./2+2W+dsb.syppteoa+dsb.sypteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+dsb.syptepteoa
"DSB.SYdWWPteAFPteOA RfePteOAPte DSB.SYdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;

locations [pte_x; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+dsb.syptepteoa.t
dorun ./S+dsb.sypteafpteoa+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+dsb.syppteoa
"DSB.SYdWWPteAFPteOA RfePteOAP DSB.SYdRWPPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;

locations [pte_x; 1:X1; fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+dsb.syppteoa.t
dorun ./S+dsb.sypteafpteoa+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafpteoa+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafpteoa+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafpteoa+tlbi.ishpteafp
"DSB.SYdWWPteAFPteOA CoePteOAPteAF TLBI.ISHdWWPteAFP CoePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [pte_y; x; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafpteoa+tlbi.ishpteafp.t
dorun ./2+2W+dsb.sypteafpteoa+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafpteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafpteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafpteoa+tlbi.ish
"DSB.SYdWWPteAFPteOA CoePteOAP TLBI.ISHdWW CoePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 STR X3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; y; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafpteoa+tlbi.ish.t
dorun ./2+2W+dsb.sypteafpteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+tlbi.ishptep
"DSB.SYdWWPteAFPteOA RfePteOAPte TLBI.ISHdRWPteP CoePPteAF"

{pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+tlbi.ishptep.t
dorun ./S+dsb.sypteafpteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+tlbi.ish
"DSB.SYdWWPteAFPteOA RfePteOAP TLBI.ISHdRW CoePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0          | P1              ;
 STR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 1:X1; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+tlbi.ish.t
dorun ./S+dsb.sypteafpteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sypteafp+dsb.sypteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sypteafp+dsb.sypteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sypteafp+dsb.sypteafpteoa
"DSB.SYdWWPteAFP CoePPteAF DSB.SYdWWPteAFPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] |             ;

locations [pte_x; y; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sypteafp+dsb.sypteafpteoa.t
dorun ./2+2W+dsb.sypteafp+dsb.sypteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sy+dsb.sypteafpteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sy+dsb.sypteafpteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sy+dsb.sypteafpteoa
"DSB.SYdWW CoePPteAF DSB.SYdWWPteAFPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 MOV W2,#1   |             ;
 STR W2,[X3] |             ;

locations [x; y; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sy+dsb.sypteafpteoa.t
dorun ./2+2W+dsb.sy+dsb.sypteafpteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+dsb.syptep
"DSB.SYdWWPteAFPteOA RfePteOAPte DSB.SYdRWPteP CoePPteAF"

{pteval_t 1:X1=0; y=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | MOV W2,#1   ;
             | STR W2,[X3] ;

locations [x; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+dsb.syptep.t
dorun ./S+dsb.sypteafpteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafpteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafpteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafpteoa+dsb.sy
"DSB.SYdWWPteAFPteOA RfePteOAP DSB.SYdRW CoePPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | MOV W2,#1   ;
             | STR W2,[X3] ;

locations [x; 1:X1; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafpteoa+dsb.sy.t
dorun ./S+dsb.sypteafpteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+dsb.sypteafpte
"DSB.SYdWWPPteOA CoePteOAPteAF DSB.SYdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 STR X3,[X2] |             ;

locations [pte_y; x; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+dsb.sypteafpte.t
dorun ./R+dsb.syppteoa+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+dsb.syppte
"DSB.SYdWWPPteOA CoePteOAP DSB.SYdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#1   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR X3,[X2] ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+dsb.syppte.t
dorun ./R+dsb.syppteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+dsb.syptepte
"DSB.SYdWWPPteOA RfePteOAPte DSB.SYdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 STR X3,[X2] |             ;

locations [x; 1:X1; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+dsb.syptepte.t
dorun ./MP+dsb.syppteoa+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+dsb.syppte
"DSB.SYdWWPPteOA RfePteOAP DSB.SYdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 STR X3,[X2] |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+dsb.syppte.t
dorun ./MP+dsb.syppteoa+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+tlbi.ishpteafp
"DSB.SYdWWPPteOA CoePteOAPteAF TLBI.ISHdWRPteAFP Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [pte_y; x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+tlbi.ishpteafp.t
dorun ./R+dsb.syppteoa+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+tlbi.ish
"DSB.SYdWWPPteOA CoePteOAP TLBI.ISHdWR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#1       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+tlbi.ish.t
dorun ./R+dsb.syppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+tlbi.ishptep
"DSB.SYdWWPPteOA RfePteOAPte TLBI.ISHdRRPteP Fre"

{pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+tlbi.ishptep.t
dorun ./MP+dsb.syppteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+tlbi.ish
"DSB.SYdWWPPteOA RfePteOAP TLBI.ISHdRR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=x;}

 P0          | P1              ;
 MOV W0,#1   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+tlbi.ish.t
dorun ./MP+dsb.syppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+dsb.sypteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+dsb.sypteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+dsb.sypteafp
"DSB.SYdWWPPteOA CoePteOAPteAF DSB.SYdWRPteAFP Fre"

{y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W3,[X2] ;
 STR X3,[X2] |             ;

locations [pte_y; x; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+dsb.sypteafp.t
dorun ./R+dsb.syppteoa+dsb.sypteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.syppteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.syppteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.syppteoa+dsb.sy
"DSB.SYdWWPPteOA CoePteOAP DSB.SYdWR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#1   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | LDR W3,[X2] ;

locations [x; y; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.syppteoa+dsb.sy.t
dorun ./R+dsb.syppteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+dsb.syptep
"DSB.SYdWWPPteOA RfePteOAPte DSB.SYdRRPteP Fre"

{pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W3,[X2] ;
 STR X3,[X2] |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+dsb.syptep.t
dorun ./MP+dsb.syppteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.syppteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.syppteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.syppteoa+dsb.sy
"DSB.SYdWWPPteOA RfePteOAP DSB.SYdRR Fre"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W3,[X2] ;
 STR X3,[X2] |             ;

locations [x; 1:X1; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.syppteoa+dsb.sy.t
dorun ./MP+dsb.syppteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.syppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syppteoas
"DSB.SYdWWPPteOA CoePteOAP DSB.SYdWWPPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#1   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;

locations [x; y; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syppteoas.t
dorun ./2+2W+dsb.syppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoa+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoa+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoa+dsb.syptepteoa
"DSB.SYdWWPPteOA RfePteOAPte DSB.SYdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 STR X3,[X2] |             ;

locations [x; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoa+dsb.syptepteoa.t
dorun ./S+dsb.syppteoa+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoas
"DSB.SYdWWPPteOA RfePteOAP DSB.SYdRWPPteOA CoePteOAP"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 STR X3,[X2] |             ;

locations [x; 1:X1; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoas.t
dorun ./S+dsb.syppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syppteoa+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.syppteoa+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syppteoa+tlbi.ishpteafp
"DSB.SYdWWPPteOA CoePteOAPteAF TLBI.ISHdWWPteAFP Coe"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#2   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [pte_y; x; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syppteoa+tlbi.ishpteafp.t
dorun ./2+2W+dsb.syppteoa+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.syppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syppteoa+tlbi.ish
"DSB.SYdWWPPteOA CoePteOAP TLBI.ISHdWW Coe"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X1=y; 1:X3=x;}

 P0          | P1              ;
 MOV W0,#2   | MOV W0,#1       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; y; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syppteoa+tlbi.ish.t
dorun ./2+2W+dsb.syppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoa+tlbi.ishptep
"DSB.SYdWWPPteOA RfePteOAPte TLBI.ISHdRWPteP Coe"

{pteval_t 1:X1=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#2   | LDR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoa+tlbi.ishptep.t
dorun ./S+dsb.syppteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoa+tlbi.ish
"DSB.SYdWWPPteOA RfePteOAP TLBI.ISHdRW Coe"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0          | P1              ;
 MOV W0,#2   | LDR W1,[X0]     ;
 STR W0,[X1] | LSR X4,X0,#12   ;
 DSB SY      | DSB ISH         ;
 STR X3,[X2] | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 1:X1; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoa+tlbi.ish.t
dorun ./S+dsb.syppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.syppteoa+dsb.sypteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.syppteoa+dsb.sypteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.syppteoa+dsb.sypteafp
"DSB.SYdWWPPteOA CoePteOAPteAF DSB.SYdWWPteAFP Coe"

{y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; pteval_t 1:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 1:X3=x;}

 P0          | P1          ;
 MOV W0,#2   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | MOV W2,#1   ;
 STR X3,[X2] | STR W2,[X3] ;

locations [pte_y; x; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.syppteoa+dsb.sypteafp.t
dorun ./2+2W+dsb.syppteoa+dsb.sypteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f 2+2W+dsb.sy+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/2+2W+dsb.sy+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 2+2W+dsb.sy+dsb.syppteoa
"DSB.SYdWW Coe DSB.SYdWWPPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X1=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#2   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] |             ;

locations [x; y; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/2+2W+dsb.sy+dsb.syppteoa.t
dorun ./2+2W+dsb.sy+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoa+dsb.syptep
"DSB.SYdWWPPteOA RfePteOAPte DSB.SYdRWPteP Coe"

{pteval_t 1:X1=0; y=0; 0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x;}

 P0          | P1          ;
 MOV W0,#2   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | MOV W2,#1   ;
 STR X3,[X2] | STR W2,[X3] ;

locations [x; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoa+dsb.syptep.t
dorun ./S+dsb.syppteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.syppteoa+dsb.sy.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.syppteoa+dsb.sy.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.syppteoa+dsb.sy
"DSB.SYdWWPPteOA RfePteOAP DSB.SYdRW Coe"

{0:X1=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0          | P1          ;
 MOV W0,#2   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | MOV W2,#1   ;
 STR X3,[X2] | STR W2,[X3] ;

locations [x; 1:X1; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.syppteoa+dsb.sy.t
dorun ./S+dsb.syppteoa+dsb.sy.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafptes
"DSB.SYdWRPteAFPte FrePtePteAF DSB.SYdWRPteAFPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 0:X4=0; pteval_t 0:X3=0; y=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 LDR X3,[X2] | LDR X3,[X2] ;
 LDR X4,[X2] | LDR X4,[X2] ;

locations [0:X4; 0:X3; 1:X4; 1:X3;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafptes.t
dorun ./SB+dsb.sypteafptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syppte+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.syppte+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syppte+dsb.sypteafpte
"DSB.SYdWRPPte FrePtePteAF DSB.SYdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X4=0; pteval_t 0:X3=0; y=0; 0:X1=x; 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 LDR X3,[X2] |             ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 0:X3; 1:X3; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syppte+dsb.sypteafpte.t
dorun ./SB+dsb.syppte+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafpte+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafpte+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafpte+tlbi.ishpteafp
"DSB.SYdWRPteAFPte FrePtePteAF TLBI.ISHdWRPteAFP FrePPteAF"

{pteval_t 0:X4=0; pteval_t 0:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x; 1:X4=y;}

 P0          | P1              ;
 STR X1,[X0] | STR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 LDR X3,[X2] | DSB ISH         ;
 LDR X4,[X2] | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [0:X4; 0:X3; 1:X3; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafpte+tlbi.ishpteafp.t
dorun ./SB+dsb.sypteafpte+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafpte+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafpte+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafpte+tlbi.ish
"DSB.SYdWRPteAFPte FrePteP TLBI.ISHdWR FrePPteAF"

{pteval_t 0:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=pte_y; 1:X1=y; 1:X2=x;}

 P0          | P1              ;
 STR X1,[X0] | MOV W0,#1       ;
 DSB SY      | STR W0,[X1]     ;
 LDR X3,[X2] | LSR X4,X1,#12   ;
             | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [y; 0:X3; 1:X3; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafpte+tlbi.ish.t
dorun ./SB+dsb.sypteafpte+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypteafp+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypteafp+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypteafp+dsb.sypteafpte
"DSB.SYdWRPteAFP FrePPteAF DSB.SYdWRPteAFPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X2=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 LDR W3,[X2] | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [0:X3; 1:X4; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypteafp+dsb.sypteafpte.t
dorun ./SB+dsb.sypteafp+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sy+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sy+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sy+dsb.sypteafpte
"DSB.SYdWR FrePPteAF DSB.SYdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 LDR W3,[X2] |             ;

locations [x; 0:X3; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sy+dsb.sypteafpte.t
dorun ./SB+dsb.sy+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafp+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafp+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafp+dsb.sypteafpte
"TLBI.ISHdWWPteAFP CoePPteAF DSB.SYdWRPteAFPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | STR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X5 | LDR X4,[X2] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [y; 1:X4; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafp+dsb.sypteafpte.t
dorun ./R+tlbi.ishpteafp+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ish+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ish+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ish+dsb.sypteafpte
"TLBI.ISHdWW CoePPteAF DSB.SYdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | STR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ish+dsb.sypteafpte.t
dorun ./R+tlbi.ish+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafp+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafp+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafp+dsb.sypteafpte
"DSB.SYdWWPteAFP CoePPteAF DSB.SYdWRPteAFPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | STR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | LDR X3,[X2] ;
 STR W2,[X3] | LDR X4,[X2] ;

locations [y; 1:X4; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafp+dsb.sypteafpte.t
dorun ./R+dsb.sypteafp+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sy+dsb.sypteafpte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sy+dsb.sypteafpte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sy+dsb.sypteafpte
"DSB.SYdWW CoePPteAF DSB.SYdWRPteAFPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 MOV W2,#1   |             ;
 STR W2,[X3] |             ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sy+dsb.sypteafpte.t
dorun ./R+dsb.sy+dsb.sypteafpte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sypptes.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sypptes.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sypptes
"DSB.SYdWRPPte FrePteP DSB.SYdWRPPte FrePteP"

{pteval_t 1:X3=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#1   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 LDR X3,[X2] | LDR X3,[X2] ;

locations [x; y; 0:X3; 1:X3; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sypptes.t
dorun ./SB+dsb.sypptes.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syppte+tlbi.ishpteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.syppte+tlbi.ishpteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syppte+tlbi.ishpteafp
"DSB.SYdWRPPte FrePtePteAF TLBI.ISHdWRPteAFP Fre"

{pteval_t 0:X4=0; pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x; 1:X4=y;}

 P0          | P1              ;
 MOV W0,#1   | STR X1,[X0]     ;
 STR W0,[X1] | LSR X5,X4,#12   ;
 DSB SY      | DSB ISH         ;
 LDR X3,[X2] | TLBI VAAE1IS,X5 ;
 LDR X4,[X2] | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; 0:X4; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syppte+tlbi.ishpteafp.t
dorun ./SB+dsb.syppte+tlbi.ishpteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syppte+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.syppte+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syppte+tlbi.ish
"DSB.SYdWRPPte FrePteP TLBI.ISHdWR Fre"

{pteval_t 0:X3=0; 0:X1=x; 0:X2=pte_y; 1:X1=y; 1:X2=x;}

 P0          | P1              ;
 MOV W0,#1   | MOV W0,#1       ;
 STR W0,[X1] | STR W0,[X1]     ;
 DSB SY      | LSR X4,X1,#12   ;
 LDR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | LDR W3,[X2]     ;

locations [x; y; 0:X3; 1:X3; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syppte+tlbi.ish.t
dorun ./SB+dsb.syppte+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.syppte+dsb.sypteafp.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.syppte+dsb.sypteafp.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.syppte+dsb.sypteafp
"DSB.SYdWRPPte FrePtePteAF DSB.SYdWRPteAFP Fre"

{pteval_t 0:X4=0; pteval_t 0:X3=0; y=0; 0:X1=x; 0:X2=pte_y; 1:X0=pte_y; pteval_t 1:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 1:X2=x;}

 P0          | P1          ;
 MOV W0,#1   | STR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR W3,[X2] ;
 LDR X3,[X2] |             ;
 LDR X4,[X2] |             ;

locations [x; 0:X4; 0:X3; 1:X3; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.syppte+dsb.sypteafp.t
dorun ./SB+dsb.syppte+dsb.sypteafp.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f SB+dsb.sy+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/SB+dsb.sy+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 SB+dsb.sy+dsb.syppte
"DSB.SYdWR Fre DSB.SYdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X2=y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#1   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 LDR W3,[X2] | LDR X3,[X2] ;

locations [x; y; 0:X3; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/SB+dsb.sy+dsb.syppte.t
dorun ./SB+dsb.sy+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ishpteafp+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ishpteafp+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ishpteafp+dsb.syppte
"TLBI.ISHdWWPteAFP Coe DSB.SYdWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X1=y; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | MOV W0,#2   ;
 LSR X5,X4,#12   | STR W0,[X1] ;
 DSB ISH         | DSB SY      ;
 TLBI VAAE1IS,X5 | LDR X3,[X2] ;
 DSB ISH         | LDR X4,[X2] ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [y; 1:X4; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ishpteafp+dsb.syppte.t
dorun ./R+tlbi.ishpteafp+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+tlbi.ish+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+tlbi.ish+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+tlbi.ish+dsb.syppte
"TLBI.ISHdWW Coe DSB.SYdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X1=y; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | MOV W0,#2   ;
 STR W0,[X1]     | STR W0,[X1] ;
 LSR X4,X1,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+tlbi.ish+dsb.syppte.t
dorun ./R+tlbi.ish+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sypteafp+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sypteafp+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sypteafp+dsb.syppte
"DSB.SYdWWPteAFP Coe DSB.SYdWRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | MOV W0,#2   ;
 DSB SY      | STR W0,[X1] ;
 MOV W2,#1   | DSB SY      ;
 STR W2,[X3] | LDR X3,[X2] ;
             | LDR X4,[X2] ;

locations [y; 1:X4; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sypteafp+dsb.syppte.t
dorun ./R+dsb.sypteafp+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f R+dsb.sy+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/R+dsb.sy+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 R+dsb.sy+dsb.syppte
"DSB.SYdWW Coe DSB.SYdWRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X1=y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | MOV W0,#2   ;
 STR W0,[X1] | STR W0,[X1] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | LDR X3,[X2] ;
 STR W2,[X3] |             ;

locations [x; y; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/R+dsb.sy+dsb.syppte.t
dorun ./R+dsb.sy+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptepteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptepteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptepteoas
"DSB.SYdRWPtePteOA RfePteOAPte DSB.SYdRWPtePteOA RfePteOAPte"

{pteval_t 1:X1=0; pteval_t 0:X1=0; y=0; x=0; 0:X0=pte_x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;

locations [0:X1; 1:X1;]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptepteoas.t
dorun ./LB+dsb.syptepteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syppteoa+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syppteoa+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syppteoa+dsb.syptepteoa
"DSB.SYdRWPPteOA RfePteOAPte DSB.SYdRWPtePteOA RfePteOAP"

{pteval_t 1:X1=0; y=0; 0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;

locations [0:X1; 1:X1; fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syppteoa+dsb.syptepteoa.t
dorun ./LB+dsb.syppteoa+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafp+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafp+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafp+dsb.syptepteoa
"TLBI.ISHdWWPteAFP RfePPte DSB.SYdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | STR X3,[X2] ;
 TLBI VAAE1IS,X5 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [pte_x; y; 1:X1; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafp+dsb.syptepteoa.t
dorun ./S+tlbi.ishpteafp+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ish+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ish+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ish+dsb.syptepteoa
"TLBI.ISHdWW RfePPte DSB.SYdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | STR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ish+dsb.syptepteoa.t
dorun ./S+tlbi.ish+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptepteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptepteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptepteoa+tlbi.ishptep
"DSB.SYdRWPtePteOA RfePteOAPte TLBI.ISHdRWPteP RfePPte"

{pteval_t 1:X1=0; pteval_t 0:X1=0; 0:X0=pte_x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x; 1:X4=y;}

 P0          | P1              ;
 LDR X1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X1; 1:X1; fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptepteoa+tlbi.ishptep.t
dorun ./LB+dsb.syptepteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptepteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptepteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptepteoa+tlbi.ish
"DSB.SYdRWPtePteOA RfePteOAP TLBI.ISHdRW RfePPte"

{pteval_t 0:X1=0; 0:X0=pte_x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0          | P1              ;
 LDR X1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X1; 1:X1; fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptepteoa+tlbi.ish.t
dorun ./LB+dsb.syptepteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafp+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafp+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafp+dsb.syptepteoa
"DSB.SYdWWPteAFP RfePPte DSB.SYdRWPtePteOA CoePteOAPteAF"

{pteval_t 1:X1=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] |             ;

locations [pte_x; y; 1:X1; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafp+dsb.syptepteoa.t
dorun ./S+dsb.sypteafp+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sy+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sy+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sy+dsb.syptepteoa
"DSB.SYdWW RfePPte DSB.SYdRWPtePteOA CoePteOAP"

{pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 MOV W2,#1   |             ;
 STR W2,[X3] |             ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sy+dsb.syptepteoa.t
dorun ./S+dsb.sy+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syptep+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syptep+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syptep+dsb.syptepteoa
"DSB.SYdRWPteP RfePPte DSB.SYdRWPtePteOA RfePteOAPte"

{pteval_t 1:X1=0; pteval_t 0:X1=0; x=0; 0:X0=pte_x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] |             ;

locations [y; 0:X1; 1:X1; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syptep+dsb.syptepteoa.t
dorun ./LB+dsb.syptep+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sy+dsb.syptepteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.sy+dsb.syptepteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sy+dsb.syptepteoa
"DSB.SYdRW RfePPte DSB.SYdRWPtePteOA RfePteOAP"

{pteval_t 1:X1=0; 0:X0=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] |             ;

locations [y; 0:X1; 1:X1; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sy+dsb.syptepteoa.t
dorun ./LB+dsb.sy+dsb.syptepteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syppteoas.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syppteoas.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syppteoas
"DSB.SYdRWPPteOA RfePteOAP DSB.SYdRWPPteOA RfePteOAP"

{0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | STR X3,[X2] ;

locations [0:X1; 1:X1; fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syppteoas.t
dorun ./LB+dsb.syppteoas.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ishpteafp+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ishpteafp+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ishpteafp+dsb.syppteoa
"TLBI.ISHdWWPteAFP Rfe DSB.SYdRWPPteOA CoePteOAPteAF"

{0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | STR X3,[X2] ;
 TLBI VAAE1IS,X5 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [pte_x; y; 1:X1; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ishpteafp+dsb.syppteoa.t
dorun ./S+tlbi.ishpteafp+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+tlbi.ish+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+tlbi.ish+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+tlbi.ish+dsb.syppteoa
"TLBI.ISHdWW Rfe DSB.SYdRWPPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | STR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+tlbi.ish+dsb.syppteoa.t
dorun ./S+tlbi.ish+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syppteoa+tlbi.ishptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syppteoa+tlbi.ishptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syppteoa+tlbi.ishptep
"DSB.SYdRWPPteOA RfePteOAPte TLBI.ISHdRWPteP Rfe"

{pteval_t 1:X1=0; 0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x; 1:X4=y;}

 P0          | P1              ;
 LDR W1,[X0] | LDR X1,[X0]     ;
 DSB SY      | LSR X5,X4,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X5 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X1; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syppteoa+tlbi.ishptep.t
dorun ./LB+dsb.syppteoa+tlbi.ishptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syppteoa+tlbi.ish.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syppteoa+tlbi.ish.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syppteoa+tlbi.ish
"DSB.SYdRWPPteOA RfePteOAP TLBI.ISHdRW Rfe"

{0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=y; 1:X3=x;}

 P0          | P1              ;
 LDR W1,[X0] | LDR W1,[X0]     ;
 DSB SY      | LSR X4,X0,#12   ;
 STR X3,[X2] | DSB ISH         ;
             | TLBI VAAE1IS,X4 ;
             | DSB ISH         ;
             | MOV W2,#1       ;
             | STR W2,[X3]     ;

locations [x; 0:X1; 1:X1; fault(P0,x); fault(P1,y); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syppteoa+tlbi.ish.t
dorun ./LB+dsb.syppteoa+tlbi.ish.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sypteafp+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sypteafp+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sypteafp+dsb.syppteoa
"DSB.SYdWWPteAFP Rfe DSB.SYdRWPPteOA CoePteOAPteAF"

{x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_y, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] |             ;

locations [pte_x; y; 1:X1; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sypteafp+dsb.syppteoa.t
dorun ./S+dsb.sypteafp+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f S+dsb.sy+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/S+dsb.sy+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 S+dsb.sy+dsb.syppteoa
"DSB.SYdWW Rfe DSB.SYdRWPPteOA CoePteOAP"

{0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | STR X3,[X2] ;
 MOV W2,#1   |             ;
 STR W2,[X3] |             ;

locations [x; y; 1:X1; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/S+dsb.sy+dsb.syppteoa.t
dorun ./S+dsb.sy+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.syppteoa+dsb.syptep.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.syppteoa+dsb.syptep.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.syppteoa+dsb.syptep
"DSB.SYdRWPPteOA RfePteOAPte DSB.SYdRWPteP Rfe"

{pteval_t 1:X1=0; y=0; 0:X0=x; 0:X2=pte_y; pteval_t 0:X3=(oa:phy_x, af:1, db:1, dbm:0, valid:1); 1:X0=pte_y; 1:X3=x;}

 P0          | P1          ;
 LDR W1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 STR X3,[X2] | MOV W2,#1   ;
             | STR W2,[X3] ;

locations [x; 0:X1; 1:X1; fault(P0,x); fault(P1,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.syppteoa+dsb.syptep.t
dorun ./LB+dsb.syppteoa+dsb.syptep.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f LB+dsb.sy+dsb.syppteoa.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/LB+dsb.sy+dsb.syppteoa.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 LB+dsb.sy+dsb.syppteoa
"DSB.SYdRW Rfe DSB.SYdRWPPteOA RfePteOAP"

{0:X0=x; 0:X3=y; 1:X0=y; 1:X2=pte_x; pteval_t 1:X3=(oa:phy_y, af:1, db:1, dbm:0, valid:1);}

 P0          | P1          ;
 LDR W1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | STR X3,[X2] ;
 STR W2,[X3] |             ;

locations [y; 0:X1; 1:X1; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/LB+dsb.sy+dsb.syppteoa.t
dorun ./LB+dsb.sy+dsb.syppteoa.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafp+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafp+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafp+dsb.syptepte
"TLBI.ISHdWWPteAFP RfePPte DSB.SYdRRPtePte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=pte_y; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR X1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X5 | LDR X4,[X2] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [y; 1:X4; 1:X1; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafp+dsb.syptepte.t
dorun ./MP+tlbi.ishpteafp+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ish+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ish+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ish+dsb.syptepte
"TLBI.ISHdWW RfePPte DSB.SYdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR X1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ish+dsb.syptepte.t
dorun ./MP+tlbi.ish+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafp+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafp+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafp+dsb.syptepte
"DSB.SYdWWPteAFP RfePPte DSB.SYdRRPtePte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; pteval_t 1:X1=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=pte_y; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR X1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | LDR X3,[X2] ;
 STR W2,[X3] | LDR X4,[X2] ;

locations [y; 1:X4; 1:X1; 1:X3; fault(P0,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafp+dsb.syptepte.t
dorun ./MP+dsb.sypteafp+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sy+dsb.syptepte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sy+dsb.syptepte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sy+dsb.syptepte
"DSB.SYdWW RfePPte DSB.SYdRRPtePte FrePteP"

{pteval_t 1:X3=0; pteval_t 1:X1=0; 0:X1=x; 0:X3=y; 1:X0=pte_y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR X1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 MOV W2,#1   |             ;
 STR W2,[X3] |             ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sy+dsb.syptepte.t
dorun ./MP+dsb.sy+dsb.syptepte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ishpteafp+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ishpteafp+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ishpteafp+dsb.syppte
"TLBI.ISHdWWPteAFP Rfe DSB.SYdRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 0:X4=x; 1:X0=y; 1:X2=pte_x;}

 P0              | P1          ;
 STR X1,[X0]     | LDR W1,[X0] ;
 LSR X5,X4,#12   | DSB SY      ;
 DSB ISH         | LDR X3,[X2] ;
 TLBI VAAE1IS,X5 | LDR X4,[X2] ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [y; 1:X4; 1:X1; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ishpteafp+dsb.syppte.t
dorun ./MP+tlbi.ishpteafp+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+tlbi.ish+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+tlbi.ish+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+tlbi.ish+dsb.syppte
"TLBI.ISHdWW Rfe DSB.SYdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x;}

 P0              | P1          ;
 MOV W0,#1       | LDR W1,[X0] ;
 STR W0,[X1]     | DSB SY      ;
 LSR X4,X1,#12   | LDR X3,[X2] ;
 DSB ISH         |             ;
 TLBI VAAE1IS,X4 |             ;
 DSB ISH         |             ;
 MOV W2,#1       |             ;
 STR W2,[X3]     |             ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+tlbi.ish+dsb.syppte.t
dorun ./MP+tlbi.ish+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sypteafp+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sypteafp+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sypteafp+dsb.syppte
"DSB.SYdWWPteAFP Rfe DSB.SYdRRPPte FrePtePteAF"

{pteval_t 1:X4=0; pteval_t 1:X3=0; x=0; 0:X0=pte_x; pteval_t 0:X1=(oa:phy_x, af:0, db:1, dbm:0, valid:1); 0:X3=y; 1:X0=y; 1:X2=pte_x;}

 P0          | P1          ;
 STR X1,[X0] | LDR W1,[X0] ;
 DSB SY      | DSB SY      ;
 MOV W2,#1   | LDR X3,[X2] ;
 STR W2,[X3] | LDR X4,[X2] ;

locations [y; 1:X4; 1:X1; 1:X3; fault(P0,y); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sypteafp+dsb.syppte.t
dorun ./MP+dsb.sypteafp+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

if [ ! -f MP+dsb.sy+dsb.syppte.no ]; then
cat <<'EOF'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results for src/DIFF/MP+dsb.sy+dsb.syppte.litmus %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AArch64 MP+dsb.sy+dsb.syppte
"DSB.SYdWW Rfe DSB.SYdRRPPte FrePteP"

{pteval_t 1:X3=0; 0:X1=x; 0:X3=y; 1:X0=y; 1:X2=pte_x;}

 P0          | P1          ;
 MOV W0,#1   | LDR W1,[X0] ;
 STR W0,[X1] | DSB SY      ;
 DSB SY      | LDR X3,[X2] ;
 MOV W2,#1   |             ;
 STR W2,[X3] |             ;

locations [x; y; 1:X1; 1:X3; fault(P0,y); fault(P0,x); fault(P1,y);]
forall (true)
Generated assembler
EOF
cat ${TDIR}/MP+dsb.sy+dsb.syppte.t
dorun ./MP+dsb.sy+dsb.syppte.flat -q $LITMUSOPTS
fi
sleep $SLEEP

cat <<'EOF'
Revision 3fb5b493f2cfba706f670bdcc1cf90dbbc393fcf, version 7.56+02~dev
Command line: /opt/KVM/bin/litmus7 -mach kvm-aarch64 -sleep 1 -a 24 -variant precise src/@all -o cross
Parameters
#define SIZE_OF_TEST 5000
#define NUMBER_OF_RUN 200
#define AVAIL 24
/* gcc options: -Wall -std=gnu99 -std=gnu99 -ffreestanding -I $(SRCDIR)/lib -I $(SRCDIR)/libfdt -Wall -Werror  -fomit-frame-pointer -Wno-frame-address   -fno-pic  -no-pie -Wmissing-parameter-type -Wold-style-declaration -Woverride-init -O2 $(call optional-ccopt, -mno-outline-atomics) -pthread */
/* barrier: userfence */
/* launch: changing */
/* affinity: none */
/* alloc: dynamic */
/* memory: direct */
/* stride: 1 */
/* safer: write */
/* preload: random */
/* speedcheck: no */
/* proc used: 24 */
EOF
echo "LITMUSOPTS=$LITMUSOPTS"
date
